import{S as tg,i as ng,s as og,e as o,k as r,w as u,t as p,M as ag,c as a,d as n,m as l,a as s,x as h,h as c,b as i,N as C,f as eg,G as e,g as f,y as g,q as _,o as v,B as b,v as sg,L as bf}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as M}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as A}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as F}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as vf}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function ig(he){let w,D,x,y,P;return y=new A({props:{code:`# !pip install opencv-python transformers accelerate
from diffusers import StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
from diffusers.utils import load_image
import numpy as np
import torch

import cv2
from PIL import Image

# download an image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)
image = np.array(image)

# get canny image
image = cv2.Canny(image, 100, 200)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)

# load control net and stable diffusion v1-5
controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)

# speed up diffusion process with faster scheduler and memory optimization
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
# remove following line if xformers is not installed
pipe.enable_xformers_memory_efficient_attention()

pipe.enable_model_cpu_offload()

# generate image
generator = torch.manual_seed(0)
image = pipe(
    "futuristic-looking woman", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># !pip install opencv-python transformers accelerate</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> cv2
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># download an image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = load_image(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.array(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># get canny image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = cv2.Canny(image, <span class="hljs-number">100</span>, <span class="hljs-number">200</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = image[:, :, <span class="hljs-literal">None</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>canny_image = Image.fromarray(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load control net and stable diffusion v1-5</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionControlNetPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># speed up diffusion process with faster scheduler and memory optimization</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># remove following line if xformers is not installed</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention()

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># generate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>generator = torch.manual_seed(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;futuristic-looking woman&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
<span class="hljs-meta">... </span>).images[<span class="hljs-number">0</span>]`}}),{c(){w=o("p"),D=p("Examples:"),x=r(),u(y.$$.fragment)},l(m){w=a(m,"P",{});var E=s(w);D=c(E,"Examples:"),E.forEach(n),x=l(m),h(y.$$.fragment,m)},m(m,E){f(m,w,E),e(w,D),f(m,x,E),g(y,m,E),P=!0},p:bf,i(m){P||(_(y.$$.fragment,m),P=!0)},o(m){v(y.$$.fragment,m),P=!1},d(m){m&&n(w),m&&n(x),b(y,m)}}}function rg(he){let w,D,x,y,P;return y=new A({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){w=o("p"),D=p("Examples:"),x=r(),u(y.$$.fragment)},l(m){w=a(m,"P",{});var E=s(w);D=c(E,"Examples:"),E.forEach(n),x=l(m),h(y.$$.fragment,m)},m(m,E){f(m,w,E),e(w,D),f(m,x,E),g(y,m,E),P=!0},p:bf,i(m){P||(_(y.$$.fragment,m),P=!0)},o(m){v(y.$$.fragment,m),P=!1},d(m){m&&n(w),m&&n(x),b(y,m)}}}function lg(he){let w,D,x,y,P;return y=new A({props:{code:`import jax
import numpy as np
import jax.numpy as jnp
from flax.jax_utils import replicate
from flax.training.common_utils import shard
from diffusers.utils import load_image
from PIL import Image
from diffusers import FlaxStableDiffusionControlNetPipeline, FlaxControlNetModel


def image_grid(imgs, rows, cols):
    w, h = imgs[0].size
    grid = Image.new("RGB", size=(cols * w, rows * h))
    for i, img in enumerate(imgs):
        grid.paste(img, box=(i % cols * w, i // cols * h))
    return grid


def create_key(seed=0):
    return jax.random.PRNGKey(seed)


rng = create_key(0)

# get canny image
canny_image = load_image(
    "https://huggingface.co/datasets/YiYiXu/test-doc-assets/resolve/main/blog_post_cell_10_output_0.jpeg"
)

prompts = "best quality, extremely detailed"
negative_prompts = "monochrome, lowres, bad anatomy, worst quality, low quality"

# load control net and stable diffusion v1-5
controlnet, controlnet_params = FlaxControlNetModel.from_pretrained(
    "lllyasviel/sd-controlnet-canny", from_pt=True, dtype=jnp.float32
)
pipe, params = FlaxStableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, from_pt=True, dtype=jnp.float32
)
params["controlnet"] = controlnet_params

num_samples = jax.device_count()
rng = jax.random.split(rng, jax.device_count())

prompt_ids = pipe.prepare_text_inputs([prompts] * num_samples)
negative_prompt_ids = pipe.prepare_text_inputs([negative_prompts] * num_samples)
processed_image = pipe.prepare_image_inputs([canny_image] * num_samples)

p_params = replicate(params)
prompt_ids = shard(prompt_ids)
negative_prompt_ids = shard(negative_prompt_ids)
processed_image = shard(processed_image)

output = pipe(
    prompt_ids=prompt_ids,
    image=processed_image,
    params=p_params,
    prng_seed=rng,
    num_inference_steps=50,
    neg_prompt_ids=negative_prompt_ids,
    jit=True,
).images

output_images = pipe.numpy_to_pil(np.asarray(output.reshape((num_samples,) + output.shape[-3:])))
output_images = image_grid(output_images, num_samples // 4, 4)
output_images.save("generated_image.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax.numpy <span class="hljs-keyword">as</span> jnp
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.jax_utils <span class="hljs-keyword">import</span> replicate
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.training.common_utils <span class="hljs-keyword">import</span> shard
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxStableDiffusionControlNetPipeline, FlaxControlNetModel


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">image_grid</span>(<span class="hljs-params">imgs, rows, cols</span>):
<span class="hljs-meta">... </span>    w, h = imgs[<span class="hljs-number">0</span>].size
<span class="hljs-meta">... </span>    grid = Image.new(<span class="hljs-string">&quot;RGB&quot;</span>, size=(cols * w, rows * h))
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> i, img <span class="hljs-keyword">in</span> <span class="hljs-built_in">enumerate</span>(imgs):
<span class="hljs-meta">... </span>        grid.paste(img, box=(i % cols * w, i // cols * h))
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> grid


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">create_key</span>(<span class="hljs-params">seed=<span class="hljs-number">0</span></span>):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> jax.random.PRNGKey(seed)


<span class="hljs-meta">&gt;&gt;&gt; </span>rng = create_key(<span class="hljs-number">0</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># get canny image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>canny_image = load_image(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://huggingface.co/datasets/YiYiXu/test-doc-assets/resolve/main/blog_post_cell_10_output_0.jpeg&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompts = <span class="hljs-string">&quot;best quality, extremely detailed&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>negative_prompts = <span class="hljs-string">&quot;monochrome, lowres, bad anatomy, worst quality, low quality&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load control net and stable diffusion v1-5</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>controlnet, controlnet_params = FlaxControlNetModel.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, from_pt=<span class="hljs-literal">True</span>, dtype=jnp.float32
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe, params = FlaxStableDiffusionControlNetPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, from_pt=<span class="hljs-literal">True</span>, dtype=jnp.float32
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>params[<span class="hljs-string">&quot;controlnet&quot;</span>] = controlnet_params

<span class="hljs-meta">&gt;&gt;&gt; </span>num_samples = jax.device_count()
<span class="hljs-meta">&gt;&gt;&gt; </span>rng = jax.random.split(rng, jax.device_count())

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids = pipe.prepare_text_inputs([prompts] * num_samples)
<span class="hljs-meta">&gt;&gt;&gt; </span>negative_prompt_ids = pipe.prepare_text_inputs([negative_prompts] * num_samples)
<span class="hljs-meta">&gt;&gt;&gt; </span>processed_image = pipe.prepare_image_inputs([canny_image] * num_samples)

<span class="hljs-meta">&gt;&gt;&gt; </span>p_params = replicate(params)
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids = shard(prompt_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>negative_prompt_ids = shard(negative_prompt_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>processed_image = shard(processed_image)

<span class="hljs-meta">&gt;&gt;&gt; </span>output = pipe(
<span class="hljs-meta">... </span>    prompt_ids=prompt_ids,
<span class="hljs-meta">... </span>    image=processed_image,
<span class="hljs-meta">... </span>    params=p_params,
<span class="hljs-meta">... </span>    prng_seed=rng,
<span class="hljs-meta">... </span>    num_inference_steps=<span class="hljs-number">50</span>,
<span class="hljs-meta">... </span>    neg_prompt_ids=negative_prompt_ids,
<span class="hljs-meta">... </span>    jit=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>).images

<span class="hljs-meta">&gt;&gt;&gt; </span>output_images = pipe.numpy_to_pil(np.asarray(output.reshape((num_samples,) + output.shape[-<span class="hljs-number">3</span>:])))
<span class="hljs-meta">&gt;&gt;&gt; </span>output_images = image_grid(output_images, num_samples // <span class="hljs-number">4</span>, <span class="hljs-number">4</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>output_images.save(<span class="hljs-string">&quot;generated_image.png&quot;</span>)`}}),{c(){w=o("p"),D=p("Examples:"),x=r(),u(y.$$.fragment)},l(m){w=a(m,"P",{});var E=s(w);D=c(E,"Examples:"),E.forEach(n),x=l(m),h(y.$$.fragment,m)},m(m,E){f(m,w,E),e(w,D),f(m,x,E),g(y,m,E),P=!0},p:bf,i(m){P||(_(y.$$.fragment,m),P=!0)},o(m){v(y.$$.fragment,m),P=!1},d(m){m&&n(w),m&&n(x),b(y,m)}}}function pg(he){let w,D,x,y,P,m,E,Ro,Fr,Hs,ee,ge,Ho,dt,qr,Wo,Lr,Ws,ft,mt,Gr,Ur,Vs,En,Or,Bs,kn,zr,Ks,Cn,Vo,Rr,Ys,_e,Hr,ut,Wr,Vr,Xs,Pn,Br,Zs,ve,Bo,ht,Kr,Yr,Ko,gt,Xr,Js,te,be,Yo,_t,Zr,Xo,Jr,Qs,ye,Zo,ne,Jo,Qr,el,Qo,tl,nl,jn,ol,al,ea,oe,ta,vt,sl,il,na,oa,rl,ll,Dn,bt,pl,ei,ae,we,aa,yt,cl,sa,dl,ti,$e,fl,ia,ml,ul,ni,xe,ra,la,pa,hl,gl,ca,Nn,wt,_l,Sn,vl,bl,oi,Ee,yl,$t,wl,$l,ai,xt,si,Tn,In,yf,ii,V,xl,da,El,kl,An,Cl,Pl,ri,Mn,jl,li,Et,pi,Fn,Dl,ci,kt,di,qn,Nl,fi,Ct,mi,Ln,Sl,ui,Gn,Un,wf,hi,ke,Tl,On,Il,Al,gi,Pt,_i,Ce,Ml,zn,Fl,ql,vi,jt,bi,Rn,Ll,yi,Dt,wi,Hn,Gl,$i,Wn,Vn,$f,xi,se,fa,Ul,Ol,Bn,zl,Rl,Ei,ie,Pe,ma,Nt,Hl,ua,Wl,ki,je,Vl,ha,Bl,Kl,Ci,Kn,Yl,Pi,De,Xl,ga,Zl,Jl,ji,re,Ne,_a,St,Ql,va,ep,Di,Yn,tp,Ni,Xn,xf,Si,Zn,np,Ti,Tt,Ii,Jn,Ef,Ai,le,Se,ba,It,op,ya,ap,Mi,Qn,sp,Fi,At,kf,qi,eo,ip,Li,Mt,Gi,Ft,Cf,Ui,pe,Te,wa,qt,rp,$a,lp,Oi,Lt,zi,Gt,Pf,Ri,ce,Ie,xa,Ut,pp,Ea,cp,Hi,B,dp,ka,fp,mp,Ca,up,hp,Wi,Ae,gp,Ot,_p,vp,Vi,de,Me,Pa,zt,bp,ja,yp,Bi,Fe,Da,q,Na,wp,$p,Sa,xp,Ep,Ta,kp,Cp,Ia,Pp,jp,j,L,qe,Rt,Dp,Np,Sp,Aa,Tp,Ip,Ma,Ap,Mp,Fa,to,Le,jf,Fp,qa,no,oo,Df,qp,G,Ge,Ht,Lp,Gp,Up,La,Op,zp,Ga,Rp,Hp,Ua,ao,so,Nf,Wp,Oa,io,ro,Sf,Vp,U,Ue,Wt,Bp,Kp,Yp,za,Xp,Zp,Ra,Jp,Qp,Ha,lo,po,Tf,ec,Wa,co,fo,If,tc,O,Oe,Vt,nc,oc,ac,Va,sc,ic,Ba,rc,lc,Ka,mo,uo,Af,pc,Ya,ho,go,Mf,cc,z,ze,Bt,dc,fc,mc,Xa,uc,hc,Kt,gc,Yt,_c,vc,bc,Za,_o,vo,Ff,yc,Ja,bo,yo,qf,wc,R,Re,Xt,$c,xc,Ec,Qa,kc,Cc,Zt,Pc,Jt,jc,Dc,Nc,es,wo,$o,Lf,Sc,ts,xo,Eo,Gf,Tc,H,He,Qt,Ic,Ac,Mc,ns,Fc,qc,os,Lc,Gc,as,ko,Co,Uf,Uc,ss,Po,jo,Of,Oc,W,en,tn,zc,Rc,is,Hc,Wc,nn,Vc,on,Bc,Kc,Yc,rs,Do,No,zf,Xc,ls,So,To,Rf,Ki,fe,We,ps,an,Zc,cs,Jc,Yi,$,sn,Qc,ds,ed,td,rn,nd,Io,od,ad,sd,K,ln,id,fs,rd,ld,Ve,pd,Y,pn,cd,ms,dd,fd,us,md,ud,Be,cn,hd,dn,gd,hs,_d,vd,bd,X,fn,yd,gs,wd,$d,_s,xd,Ed,Ke,mn,kd,un,Cd,vs,Pd,jd,Dd,S,hn,Nd,bs,Sd,Td,ys,Id,Ad,ws,Md,Fd,Ye,qd,Xe,gn,Ld,$s,Gd,Ud,Ze,_n,Od,T,zd,xs,Rd,Hd,Es,Wd,Vd,ks,Bd,Kd,Cs,Yd,Xd,Zd,Je,vn,Jd,me,Qd,Ps,ef,tf,js,nf,of,Xi,ue,Qe,Ds,bn,af,Ns,sf,Zi,I,yn,rf,Ss,lf,pf,wn,cf,Ts,df,ff,mf,Z,$n,uf,Is,hf,gf,et,Ji;return m=new F({}),dt=new F({}),_t=new F({}),yt=new F({}),xt=new A({props:{code:`from diffusers import StableDiffusionControlNetPipeline
from diffusers.utils import load_image

# Let's load the popular vermeer image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

<span class="hljs-comment"># Let&#x27;s load the popular vermeer image</span>
image = load_image(
    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
)`}}),Et=new A({props:{code:"pip install opencv-contrib-python",highlighted:'pip <span class="hljs-keyword">install</span> opencv-contrib-python'}}),kt=new A({props:{code:"pip install diffusers transformers git+https://github.com/huggingface/accelerate.git",highlighted:'pip install diffusers transformers git+https:<span class="hljs-regexp">//gi</span>thub.com<span class="hljs-regexp">/huggingface/</span>accelerate.git'}}),Ct=new A({props:{code:`import cv2
from PIL import Image
import numpy as np

image = np.array(image)

low_threshold = 100
high_threshold = 200

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)`,highlighted:`<span class="hljs-keyword">import</span> cv2
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

image = np.array(image)

low_threshold = <span class="hljs-number">100</span>
high_threshold = <span class="hljs-number">200</span>

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, <span class="hljs-literal">None</span>]
image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
canny_image = Image.fromarray(image)`}}),Pt=new A({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel
import torch

controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel
<span class="hljs-keyword">import</span> torch

controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
)`}}),jt=new A({props:{code:`from diffusers import UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

# this command loads the individual model components on GPU on-demand.
pipe.enable_model_cpu_offload()`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

<span class="hljs-comment"># this command loads the individual model components on GPU on-demand.</span>
pipe.enable_model_cpu_offload()`}}),Dt=new A({props:{code:`generator = torch.manual_seed(0)

out_image = pipe(
    "disco dancer with colorful lights", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`generator = torch.manual_seed(<span class="hljs-number">0</span>)

out_image = pipe(
    <span class="hljs-string">&quot;disco dancer with colorful lights&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
).images[<span class="hljs-number">0</span>]`}}),Nt=new F({}),St=new F({}),Tt=new A({props:{code:`from diffusers.utils import load_image
from PIL import Image
import cv2
import numpy as np
from diffusers.utils import load_image

canny_image = load_image(
    "https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png"
)
canny_image = np.array(canny_image)

low_threshold = 100
high_threshold = 200

canny_image = cv2.Canny(canny_image, low_threshold, high_threshold)

# zero out middle columns of image where pose will be overlayed
zero_start = canny_image.shape[1] // 4
zero_end = zero_start + canny_image.shape[1] // 2
canny_image[:, zero_start:zero_end] = 0

canny_image = canny_image[:, :, None]
canny_image = np.concatenate([canny_image, canny_image, canny_image], axis=2)
canny_image = Image.fromarray(canny_image)`,highlighted:`<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> cv2
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

canny_image = load_image(
    <span class="hljs-string">&quot;https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png&quot;</span>
)
canny_image = np.array(canny_image)

low_threshold = <span class="hljs-number">100</span>
high_threshold = <span class="hljs-number">200</span>

canny_image = cv2.Canny(canny_image, low_threshold, high_threshold)

<span class="hljs-comment"># zero out middle columns of image where pose will be overlayed</span>
zero_start = canny_image.shape[<span class="hljs-number">1</span>] // <span class="hljs-number">4</span>
zero_end = zero_start + canny_image.shape[<span class="hljs-number">1</span>] // <span class="hljs-number">2</span>
canny_image[:, zero_start:zero_end] = <span class="hljs-number">0</span>

canny_image = canny_image[:, :, <span class="hljs-literal">None</span>]
canny_image = np.concatenate([canny_image, canny_image, canny_image], axis=<span class="hljs-number">2</span>)
canny_image = Image.fromarray(canny_image)`}}),It=new F({}),Mt=new A({props:{code:`from controlnet_aux import OpenposeDetector
from diffusers.utils import load_image

openpose = OpenposeDetector.from_pretrained("lllyasviel/ControlNet")

openpose_image = load_image(
    "https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png"
)
openpose_image = openpose(openpose_image)`,highlighted:`<span class="hljs-keyword">from</span> controlnet_aux <span class="hljs-keyword">import</span> OpenposeDetector
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

openpose = OpenposeDetector.from_pretrained(<span class="hljs-string">&quot;lllyasviel/ControlNet&quot;</span>)

openpose_image = load_image(
    <span class="hljs-string">&quot;https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png&quot;</span>
)
openpose_image = openpose(openpose_image)`}}),qt=new F({}),Lt=new A({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
import torch

controlnet = [
    ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-openpose", torch_dtype=torch.float16),
    ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16),
]

pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

pipe.enable_xformers_memory_efficient_attention()
pipe.enable_model_cpu_offload()

prompt = "a giant standing in a fantasy landscape, best quality"
negative_prompt = "monochrome, lowres, bad anatomy, worst quality, low quality"

generator = torch.Generator(device="cpu").manual_seed(1)

images = [openpose_image, canny_image]

image = pipe(
    prompt,
    images,
    num_inference_steps=20,
    generator=generator,
    negative_prompt=negative_prompt,
    controlnet_conditioning_scale=[1.0, 0.8],
).images[0]

image.save("./multi_controlnet_output.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
<span class="hljs-keyword">import</span> torch

controlnet = [
    ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-openpose&quot;</span>, torch_dtype=torch.float16),
    ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16),
]

pipe = StableDiffusionControlNetPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

pipe.enable_xformers_memory_efficient_attention()
pipe.enable_model_cpu_offload()

prompt = <span class="hljs-string">&quot;a giant standing in a fantasy landscape, best quality&quot;</span>
negative_prompt = <span class="hljs-string">&quot;monochrome, lowres, bad anatomy, worst quality, low quality&quot;</span>

generator = torch.Generator(device=<span class="hljs-string">&quot;cpu&quot;</span>).manual_seed(<span class="hljs-number">1</span>)

images = [openpose_image, canny_image]

image = pipe(
    prompt,
    images,
    num_inference_steps=<span class="hljs-number">20</span>,
    generator=generator,
    negative_prompt=negative_prompt,
    controlnet_conditioning_scale=[<span class="hljs-number">1.0</span>, <span class="hljs-number">0.8</span>],
).images[<span class="hljs-number">0</span>]

image.save(<span class="hljs-string">&quot;./multi_controlnet_output.png&quot;</span>)`}}),Ut=new F({}),zt=new F({}),an=new F({}),sn=new M({props:{name:"class diffusers.StableDiffusionControlNetPipeline",anchor:"diffusers.StableDiffusionControlNetPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"controlnet",val:": typing.Union[diffusers.models.controlnet.ControlNetModel, typing.List[diffusers.models.controlnet.ControlNetModel], typing.Tuple[diffusers.models.controlnet.ControlNetModel], diffusers.pipelines.stable_diffusion.pipeline_stable_diffusion_controlnet.MultiControlNetModel]"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPImageProcessor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_2945/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionControlNetPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionControlNetPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionControlNetPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_2945/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.controlnet",description:`<strong>controlnet</strong> (<a href="/docs/diffusers/pr_2945/en/api/models#diffusers.ControlNetModel">ControlNetModel</a> or <code>List[ControlNetModel]</code>) &#x2014;
Provides additional conditioning to the unet during the denoising process. If you set multiple ControlNets
as a list, the outputs from each ControlNet are added together to create one combined additional
conditioning.`,name:"controlnet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_2945/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/pr_2945/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/pr_2945/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/pr_2945/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionControlNetPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionControlNetPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPImageProcessor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2945/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L150"}}),ln=new M({props:{name:"__call__",anchor:"diffusers.StableDiffusionControlNetPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image, typing.List[torch.FloatTensor], typing.List[PIL.Image.Image]] = None"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"controlnet_conditioning_scale",val:": typing.Union[float, typing.List[float]] = 1.0"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code>, <code>PIL.Image.Image</code>, <code>List[torch.FloatTensor]</code>, <code>List[PIL.Image.Image]</code>, &#x2014;
<code>List[List[torch.FloatTensor]]</code>, or <code>List[List[PIL.Image.Image]]</code>):
The ControlNet input condition. ControlNet uses this input condition to generate guidance to Unet. If
the type is specified as <code>Torch.FloatTensor</code>, it is passed to ControlNet as is. <code>PIL.Image.Image</code> can
also be accepted as an image. The dimensions of the output image defaults to <code>image</code>&#x2019;s dimensions. If
height and/or width are passed, <code>image</code> is resized according to them. If multiple ControlNets are
specified in init, images must be passed as a list such that each element of the list can be correctly
batched for input to a single controlnet.`,name:"image"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code> instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is
less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_2945/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2945/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.controlnet_conditioning_scale",description:`<strong>controlnet_conditioning_scale</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The outputs of the controlnet are multiplied by <code>controlnet_conditioning_scale</code> before they are added
to the residual in the original unet. If multiple ControlNets are specified in init, you can set the
corresponding scale as a list.`,name:"controlnet_conditioning_scale"}],source:"https://github.com/huggingface/diffusers/blob/vr_2945/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L727",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2945/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2945/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),Ve=new vf({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.example",$$slots:{default:[ig]},$$scope:{ctx:he}}}),pn=new M({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2945/src/diffusers/pipelines/pipeline_utils.py#L1367"}}),cn=new M({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2945/src/diffusers/pipelines/pipeline_utils.py#L1383"}}),fn=new M({props:{name:"enable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2945/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L230"}}),mn=new M({props:{name:"disable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2945/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L240"}}),hn=new M({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_2945/src/diffusers/pipelines/pipeline_utils.py#L1310"}}),Ye=new vf({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[rg]},$$scope:{ctx:he}}}),gn=new M({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2945/src/diffusers/pipelines/pipeline_utils.py#L1342"}}),_n=new M({props:{name:"enable_model_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2945/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L268"}}),vn=new M({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2945/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L247"}}),bn=new F({}),yn=new M({props:{name:"class diffusers.FlaxStableDiffusionControlNetPipeline",anchor:"diffusers.FlaxStableDiffusionControlNetPipeline",parameters:[{name:"vae",val:": FlaxAutoencoderKL"},{name:"text_encoder",val:": FlaxCLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": FlaxUNet2DConditionModel"},{name:"controlnet",val:": FlaxControlNetModel"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddim_flax.FlaxDDIMScheduler, diffusers.schedulers.scheduling_pndm_flax.FlaxPNDMScheduler, diffusers.schedulers.scheduling_lms_discrete_flax.FlaxLMSDiscreteScheduler, diffusers.schedulers.scheduling_dpmsolver_multistep_flax.FlaxDPMSolverMultistepScheduler]"},{name:"safety_checker",val:": FlaxStableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_2945/en/api/models#diffusers.FlaxAutoencoderKL">FlaxAutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>FlaxCLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.FlaxCLIPTextModel" rel="nofollow">CLIP</a>,
specifically the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_2945/en/api/models#diffusers.FlaxUNet2DConditionModel">FlaxUNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.controlnet",description:`<strong>controlnet</strong> (<a href="/docs/diffusers/pr_2945/en/api/models#diffusers.FlaxControlNetModel">FlaxControlNetModel</a> &#x2014;
Provides additional conditioning to the unet during the denoising process.`,name:"controlnet"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_2945/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<code>FlaxDDIMScheduler</code>, <code>FlaxLMSDiscreteScheduler</code>, <code>FlaxPNDMScheduler</code>, or
<code>FlaxDPMSolverMultistepScheduler</code>.`,name:"scheduler"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>FlaxStableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_2945/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion_controlnet.py#L119"}}),$n=new M({props:{name:"__call__",anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__",parameters:[{name:"prompt_ids",val:": array"},{name:"image",val:": array"},{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"prng_seed",val:": PRNGKeyArray"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": typing.Union[float, array] = 7.5"},{name:"latents",val:": array = None"},{name:"neg_prompt_ids",val:": array = None"},{name:"controlnet_conditioning_scale",val:": typing.Union[float, array] = 1.0"},{name:"return_dict",val:": bool = True"},{name:"jit",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.prompt_ids",description:`<strong>prompt_ids</strong> (<code>jnp.array</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt_ids"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.image",description:`<strong>image</strong> (<code>jnp.array</code>) &#x2014;
Array representing the ControlNet input condition. ControlNet use this input condition to generate
guidance to Unet.`,name:"image"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.params",description:"<strong>params</strong> (<code>Dict</code> or <code>FrozenDict</code>) &#x2014; Dictionary containing the model parameters/weights",name:"params"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.prng_seed",description:"<strong>prng_seed</strong> (<code>jax.random.KeyArray</code> or <code>jax.Array</code>) &#x2014; Array containing random number generator key",name:"prng_seed"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.latents",description:`<strong>latents</strong> (<code>jnp.array</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.controlnet_conditioning_scale",description:`<strong>controlnet_conditioning_scale</strong> (<code>float</code> or <code>jnp.array</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The outputs of the controlnet are multiplied by <code>controlnet_conditioning_scale</code> before they are added
to the residual in the original unet.`,name:"controlnet_conditioning_scale"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>FlaxStableDiffusionPipelineOutput</code> instead of
a plain tuple.`,name:"return_dict"},{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.jit",description:`<strong>jit</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to run <code>pmap</code> versions of the generation and safety scoring functions. NOTE: This argument
exists because <code>__call__</code> is not yet end-to-end pmap-able. It will be removed in a future release.`,name:"jit"}],source:"https://github.com/huggingface/diffusers/blob/vr_2945/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion_controlnet.py#L357",returnDescription:`
<p><code>FlaxStableDiffusionPipelineOutput</code> if <code>return_dict</code> is True, otherwise a
<code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><code>FlaxStableDiffusionPipelineOutput</code> or <code>tuple</code></p>
`}}),et=new vf({props:{anchor:"diffusers.FlaxStableDiffusionControlNetPipeline.__call__.example",$$slots:{default:[lg]},$$scope:{ctx:he}}}),{c(){w=o("meta"),D=r(),x=o("h1"),y=o("a"),P=o("span"),u(m.$$.fragment),E=r(),Ro=o("span"),Fr=p("Text-to-Image Generation with ControlNet Conditioning"),Hs=r(),ee=o("h2"),ge=o("a"),Ho=o("span"),u(dt.$$.fragment),qr=r(),Wo=o("span"),Lr=p("Overview"),Ws=r(),ft=o("p"),mt=o("a"),Gr=p("Adding Conditional Control to Text-to-Image Diffusion Models"),Ur=p(" by Lvmin Zhang and Maneesh Agrawala."),Vs=r(),En=o("p"),Or=p("Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),Bs=r(),kn=o("p"),zr=p("The abstract of the paper is the following:"),Ks=r(),Cn=o("p"),Vo=o("em"),Rr=p("We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),Ys=r(),_e=o("p"),Hr=p("This model was contributed by the amazing community contributor "),ut=o("a"),Wr=p("takuma104"),Vr=p(" \u2764\uFE0F ."),Xs=r(),Pn=o("p"),Br=p("Resources:"),Zs=r(),ve=o("ul"),Bo=o("li"),ht=o("a"),Kr=p("Paper"),Yr=r(),Ko=o("li"),gt=o("a"),Xr=p("Original Code"),Js=r(),te=o("h2"),be=o("a"),Yo=o("span"),u(_t.$$.fragment),Zr=r(),Xo=o("span"),Jr=p("Available Pipelines:"),Qs=r(),ye=o("table"),Zo=o("thead"),ne=o("tr"),Jo=o("th"),Qr=p("Pipeline"),el=r(),Qo=o("th"),tl=p("Tasks"),nl=r(),jn=o("th"),ol=p("Demo"),al=r(),ea=o("tbody"),oe=o("tr"),ta=o("td"),vt=o("a"),sl=p("StableDiffusionControlNetPipeline"),il=r(),na=o("td"),oa=o("em"),rl=p("Text-to-Image Generation with ControlNet Conditioning"),ll=r(),Dn=o("td"),bt=o("a"),pl=p("Colab Example"),ei=r(),ae=o("h2"),we=o("a"),aa=o("span"),u(yt.$$.fragment),cl=r(),sa=o("span"),dl=p("Usage example"),ti=r(),$e=o("p"),fl=p("In the following we give a simple example of how to use a "),ia=o("em"),ml=p("ControlNet"),ul=p(` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),ni=r(),xe=o("ul"),ra=o("li"),la=o("ol"),pa=o("li"),hl=p("Take an image and run it through a pre-conditioning processor."),gl=r(),ca=o("li"),Nn=o("ol"),wt=o("li"),_l=p("Run the pre-processed image through the "),Sn=o("a"),vl=p("StableDiffusionControlNetPipeline"),bl=p("."),oi=r(),Ee=o("p"),yl=p("Let\u2019s have a look at a simple example using the "),$t=o("a"),wl=p("Canny Edge ControlNet"),$l=p("."),ai=r(),u(xt.$$.fragment),si=r(),Tn=o("p"),In=o("img"),ii=r(),V=o("p"),xl=p("Next, we process the image to get the canny image. This is step "),da=o("em"),El=p("1."),kl=p(" - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),An=o("a"),Cl=p("official checkpoints"),Pl=p(" for more information about other models."),ri=r(),Mn=o("p"),jl=p("First, we need to install opencv:"),li=r(),u(Et.$$.fragment),pi=r(),Fn=o("p"),Dl=p("Next, let\u2019s also install all required Hugging Face libraries:"),ci=r(),u(kt.$$.fragment),di=r(),qn=o("p"),Nl=p("Then we can retrieve the canny edges of the image."),fi=r(),u(Ct.$$.fragment),mi=r(),Ln=o("p"),Sl=p("Let\u2019s take a look at the processed image."),ui=r(),Gn=o("p"),Un=o("img"),hi=r(),ke=o("p"),Tl=p("Now, we load the official "),On=o("a"),Il=p("Stable Diffusion 1.5 Model"),Al=p(" as well as the ControlNet for canny edges."),gi=r(),u(Pt.$$.fragment),_i=r(),Ce=o("p"),Ml=p("To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),zn=o("a"),Fl=p("UniPCMultistepScheduler"),ql=p("."),vi=r(),u(jt.$$.fragment),bi=r(),Rn=o("p"),Ll=p("Finally, we can run the pipeline:"),yi=r(),u(Dt.$$.fragment),wi=r(),Hn=o("p"),Gl=p("This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),$i=r(),Wn=o("p"),Vn=o("img"),xi=r(),se=o("p"),fa=o("strong"),Ul=p("Note"),Ol=p(": To see how to run all other ControlNet checkpoints, please have a look at "),Bn=o("a"),zl=p("ControlNet with Stable Diffusion 1.5"),Rl=p("."),Ei=r(),ie=o("h2"),Pe=o("a"),ma=o("span"),u(Nt.$$.fragment),Hl=r(),ua=o("span"),Wl=p("Combining multiple conditionings"),ki=r(),je=o("p"),Vl=p("Multiple ControlNet conditionings can be combined for a single image generation. Pass a list of ControlNets to the pipeline\u2019s constructor and a corresponding list of conditionings to "),ha=o("code"),Bl=p("__call__"),Kl=p("."),Ci=r(),Kn=o("p"),Yl=p("When combining conditionings, it is helpful to mask conditionings such that they do not overlap. In the example, we mask the middle of the canny map where the pose conditioning is located."),Pi=r(),De=o("p"),Xl=p("It can also be helpful to vary the "),ga=o("code"),Zl=p("controlnet_conditioning_scales"),Jl=p(" to emphasize one conditioning over the other."),ji=r(),re=o("h3"),Ne=o("a"),_a=o("span"),u(St.$$.fragment),Ql=r(),va=o("span"),ep=p("Canny conditioning"),Di=r(),Yn=o("p"),tp=p("The original image:"),Ni=r(),Xn=o("img"),Si=r(),Zn=o("p"),np=p("Prepare the conditioning:"),Ti=r(),u(Tt.$$.fragment),Ii=r(),Jn=o("img"),Ai=r(),le=o("h3"),Se=o("a"),ba=o("span"),u(It.$$.fragment),op=r(),ya=o("span"),ap=p("Openpose conditioning"),Mi=r(),Qn=o("p"),sp=p("The original image:"),Fi=r(),At=o("img"),qi=r(),eo=o("p"),ip=p("Prepare the conditioning:"),Li=r(),u(Mt.$$.fragment),Gi=r(),Ft=o("img"),Ui=r(),pe=o("h3"),Te=o("a"),wa=o("span"),u(qt.$$.fragment),rp=r(),$a=o("span"),lp=p("Running ControlNet with multiple conditionings"),Oi=r(),u(Lt.$$.fragment),zi=r(),Gt=o("img"),Ri=r(),ce=o("h2"),Ie=o("a"),xa=o("span"),u(Ut.$$.fragment),pp=r(),Ea=o("span"),cp=p("Available checkpoints"),Hi=r(),B=o("p"),dp=p("ControlNet requires a "),ka=o("em"),fp=p("control image"),mp=p(" in addition to the text-to-image "),Ca=o("em"),up=p("prompt"),hp=p(`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),Wi=r(),Ae=o("p"),gp=p("All checkpoints can be found under the authors\u2019 namespace "),Ot=o("a"),_p=p("lllyasviel"),vp=p("."),Vi=r(),de=o("h3"),Me=o("a"),Pa=o("span"),u(zt.$$.fragment),bp=r(),ja=o("span"),yp=p("ControlNet with Stable Diffusion 1.5"),Bi=r(),Fe=o("table"),Da=o("thead"),q=o("tr"),Na=o("th"),wp=p("Model Name"),$p=r(),Sa=o("th"),xp=p("Control Image Overview"),Ep=r(),Ta=o("th"),kp=p("Control Image Example"),Cp=r(),Ia=o("th"),Pp=p("Generated Image Example"),jp=r(),j=o("tbody"),L=o("tr"),qe=o("td"),Rt=o("a"),Dp=p("lllyasviel/sd-controlnet-canny"),Np=o("br"),Sp=r(),Aa=o("em"),Tp=p("Trained with canny edge detection"),Ip=r(),Ma=o("td"),Ap=p("A monochrome image with white edges on a black background."),Mp=r(),Fa=o("td"),to=o("a"),Le=o("img"),Fp=r(),qa=o("td"),no=o("a"),oo=o("img"),qp=r(),G=o("tr"),Ge=o("td"),Ht=o("a"),Lp=p("lllyasviel/sd-controlnet-depth"),Gp=o("br"),Up=r(),La=o("em"),Op=p("Trained with Midas depth estimation"),zp=r(),Ga=o("td"),Rp=p("A grayscale image with black representing deep areas and white representing shallow areas."),Hp=r(),Ua=o("td"),ao=o("a"),so=o("img"),Wp=r(),Oa=o("td"),io=o("a"),ro=o("img"),Vp=r(),U=o("tr"),Ue=o("td"),Wt=o("a"),Bp=p("lllyasviel/sd-controlnet-hed"),Kp=o("br"),Yp=r(),za=o("em"),Xp=p("Trained with HED edge detection (soft edge)"),Zp=r(),Ra=o("td"),Jp=p("A monochrome image with white soft edges on a black background."),Qp=r(),Ha=o("td"),lo=o("a"),po=o("img"),ec=r(),Wa=o("td"),co=o("a"),fo=o("img"),tc=r(),O=o("tr"),Oe=o("td"),Vt=o("a"),nc=p("lllyasviel/sd-controlnet-mlsd"),oc=o("br"),ac=r(),Va=o("em"),sc=p("Trained with M-LSD line detection"),ic=r(),Ba=o("td"),rc=p("A monochrome image composed only of white straight lines on a black background."),lc=r(),Ka=o("td"),mo=o("a"),uo=o("img"),pc=r(),Ya=o("td"),ho=o("a"),go=o("img"),cc=r(),z=o("tr"),ze=o("td"),Bt=o("a"),dc=p("lllyasviel/sd-controlnet-normal"),fc=o("br"),mc=r(),Xa=o("em"),uc=p("Trained with normal map"),hc=r(),Kt=o("td"),gc=p("A "),Yt=o("a"),_c=p("normal mapped"),vc=p(" image."),bc=r(),Za=o("td"),_o=o("a"),vo=o("img"),yc=r(),Ja=o("td"),bo=o("a"),yo=o("img"),wc=r(),R=o("tr"),Re=o("td"),Xt=o("a"),$c=p("lllyasviel/sd-controlnet-openpose"),xc=o("br"),Ec=r(),Qa=o("em"),kc=p("Trained with OpenPose bone image"),Cc=r(),Zt=o("td"),Pc=p("A "),Jt=o("a"),jc=p("OpenPose bone"),Dc=p(" image."),Nc=r(),es=o("td"),wo=o("a"),$o=o("img"),Sc=r(),ts=o("td"),xo=o("a"),Eo=o("img"),Tc=r(),H=o("tr"),He=o("td"),Qt=o("a"),Ic=p("lllyasviel/sd-controlnet-scribble"),Ac=o("br"),Mc=r(),ns=o("em"),Fc=p("Trained with human scribbles"),qc=r(),os=o("td"),Lc=p("A hand-drawn monochrome image with white outlines on a black background."),Gc=r(),as=o("td"),ko=o("a"),Co=o("img"),Uc=r(),ss=o("td"),Po=o("a"),jo=o("img"),Oc=r(),W=o("tr"),en=o("td"),tn=o("a"),zc=p("lllyasviel/sd-controlnet-seg"),Rc=o("br"),is=o("em"),Hc=p("Trained with semantic segmentation"),Wc=r(),nn=o("td"),Vc=p("An "),on=o("a"),Bc=p("ADE20K"),Kc=p("\u2019s segmentation protocol image."),Yc=r(),rs=o("td"),Do=o("a"),No=o("img"),Xc=r(),ls=o("td"),So=o("a"),To=o("img"),Ki=r(),fe=o("h2"),We=o("a"),ps=o("span"),u(an.$$.fragment),Zc=r(),cs=o("span"),Jc=p("StableDiffusionControlNetPipeline"),Yi=r(),$=o("div"),u(sn.$$.fragment),Qc=r(),ds=o("p"),ed=p("Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),td=r(),rn=o("p"),nd=p("This model inherits from "),Io=o("a"),od=p("DiffusionPipeline"),ad=p(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),sd=r(),K=o("div"),u(ln.$$.fragment),id=r(),fs=o("p"),rd=p("Function invoked when calling the pipeline for generation."),ld=r(),u(Ve.$$.fragment),pd=r(),Y=o("div"),u(pn.$$.fragment),cd=r(),ms=o("p"),dd=p("Enable sliced attention computation."),fd=r(),us=o("p"),md=p(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),ud=r(),Be=o("div"),u(cn.$$.fragment),hd=r(),dn=o("p"),gd=p("Disable sliced attention computation. If "),hs=o("code"),_d=p("enable_attention_slicing"),vd=p(` was previously invoked, this method will go
back to computing attention in one step.`),bd=r(),X=o("div"),u(fn.$$.fragment),yd=r(),gs=o("p"),wd=p("Enable sliced VAE decoding."),$d=r(),_s=o("p"),xd=p(`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),Ed=r(),Ke=o("div"),u(mn.$$.fragment),kd=r(),un=o("p"),Cd=p("Disable sliced VAE decoding. If "),vs=o("code"),Pd=p("enable_vae_slicing"),jd=p(` was previously invoked, this method will go back to
computing decoding in one step.`),Dd=r(),S=o("div"),u(hn.$$.fragment),Nd=r(),bs=o("p"),Sd=p("Enable memory efficient attention as implemented in xformers."),Td=r(),ys=o("p"),Id=p(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Ad=r(),ws=o("p"),Md=p(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Fd=r(),u(Ye.$$.fragment),qd=r(),Xe=o("div"),u(gn.$$.fragment),Ld=r(),$s=o("p"),Gd=p("Disable memory efficient attention as implemented in xformers."),Ud=r(),Ze=o("div"),u(_n.$$.fragment),Od=r(),T=o("p"),zd=p(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),xs=o("code"),Rd=p("enable_sequential_cpu_offload"),Hd=p(", this method moves one whole model at a time to the GPU when its "),Es=o("code"),Wd=p("forward"),Vd=p(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),ks=o("code"),Bd=p("enable_sequential_cpu_offload"),Kd=p(", but performance is much better due to the iterative execution of the "),Cs=o("code"),Yd=p("unet"),Xd=p("."),Zd=r(),Je=o("div"),u(vn.$$.fragment),Jd=r(),me=o("p"),Qd=p(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),Ps=o("code"),ef=p("torch.device('meta') and loaded to GPU only when their specific submodule has its "),tf=p("forward"),js=o("code"),nf=p("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),of=p("enable_model_cpu_offload`, but performance is lower."),Xi=r(),ue=o("h2"),Qe=o("a"),Ds=o("span"),u(bn.$$.fragment),af=r(),Ns=o("span"),sf=p("FlaxStableDiffusionControlNetPipeline"),Zi=r(),I=o("div"),u(yn.$$.fragment),rf=r(),Ss=o("p"),lf=p("Pipeline for text-to-image generation using Stable Diffusion with ControlNet Guidance."),pf=r(),wn=o("p"),cf=p("This model inherits from "),Ts=o("code"),df=p("FlaxDiffusionPipeline"),ff=p(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),mf=r(),Z=o("div"),u($n.$$.fragment),uf=r(),Is=o("p"),hf=p("Function invoked when calling the pipeline for generation."),gf=r(),u(et.$$.fragment),this.h()},l(t){const d=ag('[data-svelte="svelte-1phssyn"]',document.head);w=a(d,"META",{name:!0,content:!0}),d.forEach(n),D=l(t),x=a(t,"H1",{class:!0});var xn=s(x);y=a(xn,"A",{id:!0,class:!0,href:!0});var As=s(y);P=a(As,"SPAN",{});var Ms=s(P);h(m.$$.fragment,Ms),Ms.forEach(n),As.forEach(n),E=l(xn),Ro=a(xn,"SPAN",{});var Hf=s(Ro);Fr=c(Hf,"Text-to-Image Generation with ControlNet Conditioning"),Hf.forEach(n),xn.forEach(n),Hs=l(t),ee=a(t,"H2",{class:!0});var Qi=s(ee);ge=a(Qi,"A",{id:!0,class:!0,href:!0});var Wf=s(ge);Ho=a(Wf,"SPAN",{});var Vf=s(Ho);h(dt.$$.fragment,Vf),Vf.forEach(n),Wf.forEach(n),qr=l(Qi),Wo=a(Qi,"SPAN",{});var Bf=s(Wo);Lr=c(Bf,"Overview"),Bf.forEach(n),Qi.forEach(n),Ws=l(t),ft=a(t,"P",{});var _f=s(ft);mt=a(_f,"A",{href:!0,rel:!0});var Kf=s(mt);Gr=c(Kf,"Adding Conditional Control to Text-to-Image Diffusion Models"),Kf.forEach(n),Ur=c(_f," by Lvmin Zhang and Maneesh Agrawala."),_f.forEach(n),Vs=l(t),En=a(t,"P",{});var Yf=s(En);Or=c(Yf,"Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),Yf.forEach(n),Bs=l(t),kn=a(t,"P",{});var Xf=s(kn);zr=c(Xf,"The abstract of the paper is the following:"),Xf.forEach(n),Ks=l(t),Cn=a(t,"P",{});var Zf=s(Cn);Vo=a(Zf,"EM",{});var Jf=s(Vo);Rr=c(Jf,"We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),Jf.forEach(n),Zf.forEach(n),Ys=l(t),_e=a(t,"P",{});var er=s(_e);Hr=c(er,"This model was contributed by the amazing community contributor "),ut=a(er,"A",{href:!0,rel:!0});var Qf=s(ut);Wr=c(Qf,"takuma104"),Qf.forEach(n),Vr=c(er," \u2764\uFE0F ."),er.forEach(n),Xs=l(t),Pn=a(t,"P",{});var em=s(Pn);Br=c(em,"Resources:"),em.forEach(n),Zs=l(t),ve=a(t,"UL",{});var tr=s(ve);Bo=a(tr,"LI",{});var tm=s(Bo);ht=a(tm,"A",{href:!0,rel:!0});var nm=s(ht);Kr=c(nm,"Paper"),nm.forEach(n),tm.forEach(n),Yr=l(tr),Ko=a(tr,"LI",{});var om=s(Ko);gt=a(om,"A",{href:!0,rel:!0});var am=s(gt);Xr=c(am,"Original Code"),am.forEach(n),om.forEach(n),tr.forEach(n),Js=l(t),te=a(t,"H2",{class:!0});var nr=s(te);be=a(nr,"A",{id:!0,class:!0,href:!0});var sm=s(be);Yo=a(sm,"SPAN",{});var im=s(Yo);h(_t.$$.fragment,im),im.forEach(n),sm.forEach(n),Zr=l(nr),Xo=a(nr,"SPAN",{});var rm=s(Xo);Jr=c(rm,"Available Pipelines:"),rm.forEach(n),nr.forEach(n),Qs=l(t),ye=a(t,"TABLE",{});var or=s(ye);Zo=a(or,"THEAD",{});var lm=s(Zo);ne=a(lm,"TR",{});var Ao=s(ne);Jo=a(Ao,"TH",{});var pm=s(Jo);Qr=c(pm,"Pipeline"),pm.forEach(n),el=l(Ao),Qo=a(Ao,"TH",{});var cm=s(Qo);tl=c(cm,"Tasks"),cm.forEach(n),nl=l(Ao),jn=a(Ao,"TH",{align:!0});var dm=s(jn);ol=c(dm,"Demo"),dm.forEach(n),Ao.forEach(n),lm.forEach(n),al=l(or),ea=a(or,"TBODY",{});var fm=s(ea);oe=a(fm,"TR",{});var Mo=s(oe);ta=a(Mo,"TD",{});var mm=s(ta);vt=a(mm,"A",{href:!0,rel:!0});var um=s(vt);sl=c(um,"StableDiffusionControlNetPipeline"),um.forEach(n),mm.forEach(n),il=l(Mo),na=a(Mo,"TD",{});var hm=s(na);oa=a(hm,"EM",{});var gm=s(oa);rl=c(gm,"Text-to-Image Generation with ControlNet Conditioning"),gm.forEach(n),hm.forEach(n),ll=l(Mo),Dn=a(Mo,"TD",{align:!0});var _m=s(Dn);bt=a(_m,"A",{href:!0,rel:!0});var vm=s(bt);pl=c(vm,"Colab Example"),vm.forEach(n),_m.forEach(n),Mo.forEach(n),fm.forEach(n),or.forEach(n),ei=l(t),ae=a(t,"H2",{class:!0});var ar=s(ae);we=a(ar,"A",{id:!0,class:!0,href:!0});var bm=s(we);aa=a(bm,"SPAN",{});var ym=s(aa);h(yt.$$.fragment,ym),ym.forEach(n),bm.forEach(n),cl=l(ar),sa=a(ar,"SPAN",{});var wm=s(sa);dl=c(wm,"Usage example"),wm.forEach(n),ar.forEach(n),ti=l(t),$e=a(t,"P",{});var sr=s($e);fl=c(sr,"In the following we give a simple example of how to use a "),ia=a(sr,"EM",{});var $m=s(ia);ml=c($m,"ControlNet"),$m.forEach(n),ul=c(sr,` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),sr.forEach(n),ni=l(t),xe=a(t,"UL",{});var ir=s(xe);ra=a(ir,"LI",{});var xm=s(ra);la=a(xm,"OL",{});var Em=s(la);pa=a(Em,"LI",{});var km=s(pa);hl=c(km,"Take an image and run it through a pre-conditioning processor."),km.forEach(n),Em.forEach(n),xm.forEach(n),gl=l(ir),ca=a(ir,"LI",{});var Cm=s(ca);Nn=a(Cm,"OL",{start:!0});var Pm=s(Nn);wt=a(Pm,"LI",{});var rr=s(wt);_l=c(rr,"Run the pre-processed image through the "),Sn=a(rr,"A",{href:!0});var jm=s(Sn);vl=c(jm,"StableDiffusionControlNetPipeline"),jm.forEach(n),bl=c(rr,"."),rr.forEach(n),Pm.forEach(n),Cm.forEach(n),ir.forEach(n),oi=l(t),Ee=a(t,"P",{});var lr=s(Ee);yl=c(lr,"Let\u2019s have a look at a simple example using the "),$t=a(lr,"A",{href:!0,rel:!0});var Dm=s($t);wl=c(Dm,"Canny Edge ControlNet"),Dm.forEach(n),$l=c(lr,"."),lr.forEach(n),ai=l(t),h(xt.$$.fragment,t),si=l(t),Tn=a(t,"P",{});var Nm=s(Tn);In=a(Nm,"IMG",{src:!0,alt:!0}),Nm.forEach(n),ii=l(t),V=a(t,"P",{});var Fo=s(V);xl=c(Fo,"Next, we process the image to get the canny image. This is step "),da=a(Fo,"EM",{});var Sm=s(da);El=c(Sm,"1."),Sm.forEach(n),kl=c(Fo," - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),An=a(Fo,"A",{href:!0});var Tm=s(An);Cl=c(Tm,"official checkpoints"),Tm.forEach(n),Pl=c(Fo," for more information about other models."),Fo.forEach(n),ri=l(t),Mn=a(t,"P",{});var Im=s(Mn);jl=c(Im,"First, we need to install opencv:"),Im.forEach(n),li=l(t),h(Et.$$.fragment,t),pi=l(t),Fn=a(t,"P",{});var Am=s(Fn);Dl=c(Am,"Next, let\u2019s also install all required Hugging Face libraries:"),Am.forEach(n),ci=l(t),h(kt.$$.fragment,t),di=l(t),qn=a(t,"P",{});var Mm=s(qn);Nl=c(Mm,"Then we can retrieve the canny edges of the image."),Mm.forEach(n),fi=l(t),h(Ct.$$.fragment,t),mi=l(t),Ln=a(t,"P",{});var Fm=s(Ln);Sl=c(Fm,"Let\u2019s take a look at the processed image."),Fm.forEach(n),ui=l(t),Gn=a(t,"P",{});var qm=s(Gn);Un=a(qm,"IMG",{src:!0,alt:!0}),qm.forEach(n),hi=l(t),ke=a(t,"P",{});var pr=s(ke);Tl=c(pr,"Now, we load the official "),On=a(pr,"A",{href:!0});var Lm=s(On);Il=c(Lm,"Stable Diffusion 1.5 Model"),Lm.forEach(n),Al=c(pr," as well as the ControlNet for canny edges."),pr.forEach(n),gi=l(t),h(Pt.$$.fragment,t),_i=l(t),Ce=a(t,"P",{});var cr=s(Ce);Ml=c(cr,"To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),zn=a(cr,"A",{href:!0});var Gm=s(zn);Fl=c(Gm,"UniPCMultistepScheduler"),Gm.forEach(n),ql=c(cr,"."),cr.forEach(n),vi=l(t),h(jt.$$.fragment,t),bi=l(t),Rn=a(t,"P",{});var Um=s(Rn);Ll=c(Um,"Finally, we can run the pipeline:"),Um.forEach(n),yi=l(t),h(Dt.$$.fragment,t),wi=l(t),Hn=a(t,"P",{});var Om=s(Hn);Gl=c(Om,"This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),Om.forEach(n),$i=l(t),Wn=a(t,"P",{});var zm=s(Wn);Vn=a(zm,"IMG",{src:!0,alt:!0}),zm.forEach(n),xi=l(t),se=a(t,"P",{});var Fs=s(se);fa=a(Fs,"STRONG",{});var Rm=s(fa);Ul=c(Rm,"Note"),Rm.forEach(n),Ol=c(Fs,": To see how to run all other ControlNet checkpoints, please have a look at "),Bn=a(Fs,"A",{href:!0});var Hm=s(Bn);zl=c(Hm,"ControlNet with Stable Diffusion 1.5"),Hm.forEach(n),Rl=c(Fs,"."),Fs.forEach(n),Ei=l(t),ie=a(t,"H2",{class:!0});var dr=s(ie);Pe=a(dr,"A",{id:!0,class:!0,href:!0});var Wm=s(Pe);ma=a(Wm,"SPAN",{});var Vm=s(ma);h(Nt.$$.fragment,Vm),Vm.forEach(n),Wm.forEach(n),Hl=l(dr),ua=a(dr,"SPAN",{});var Bm=s(ua);Wl=c(Bm,"Combining multiple conditionings"),Bm.forEach(n),dr.forEach(n),ki=l(t),je=a(t,"P",{});var fr=s(je);Vl=c(fr,"Multiple ControlNet conditionings can be combined for a single image generation. Pass a list of ControlNets to the pipeline\u2019s constructor and a corresponding list of conditionings to "),ha=a(fr,"CODE",{});var Km=s(ha);Bl=c(Km,"__call__"),Km.forEach(n),Kl=c(fr,"."),fr.forEach(n),Ci=l(t),Kn=a(t,"P",{});var Ym=s(Kn);Yl=c(Ym,"When combining conditionings, it is helpful to mask conditionings such that they do not overlap. In the example, we mask the middle of the canny map where the pose conditioning is located."),Ym.forEach(n),Pi=l(t),De=a(t,"P",{});var mr=s(De);Xl=c(mr,"It can also be helpful to vary the "),ga=a(mr,"CODE",{});var Xm=s(ga);Zl=c(Xm,"controlnet_conditioning_scales"),Xm.forEach(n),Jl=c(mr," to emphasize one conditioning over the other."),mr.forEach(n),ji=l(t),re=a(t,"H3",{class:!0});var ur=s(re);Ne=a(ur,"A",{id:!0,class:!0,href:!0});var Zm=s(Ne);_a=a(Zm,"SPAN",{});var Jm=s(_a);h(St.$$.fragment,Jm),Jm.forEach(n),Zm.forEach(n),Ql=l(ur),va=a(ur,"SPAN",{});var Qm=s(va);ep=c(Qm,"Canny conditioning"),Qm.forEach(n),ur.forEach(n),Di=l(t),Yn=a(t,"P",{});var eu=s(Yn);tp=c(eu,"The original image:"),eu.forEach(n),Ni=l(t),Xn=a(t,"IMG",{src:!0}),Si=l(t),Zn=a(t,"P",{});var tu=s(Zn);np=c(tu,"Prepare the conditioning:"),tu.forEach(n),Ti=l(t),h(Tt.$$.fragment,t),Ii=l(t),Jn=a(t,"IMG",{src:!0}),Ai=l(t),le=a(t,"H3",{class:!0});var hr=s(le);Se=a(hr,"A",{id:!0,class:!0,href:!0});var nu=s(Se);ba=a(nu,"SPAN",{});var ou=s(ba);h(It.$$.fragment,ou),ou.forEach(n),nu.forEach(n),op=l(hr),ya=a(hr,"SPAN",{});var au=s(ya);ap=c(au,"Openpose conditioning"),au.forEach(n),hr.forEach(n),Mi=l(t),Qn=a(t,"P",{});var su=s(Qn);sp=c(su,"The original image:"),su.forEach(n),Fi=l(t),At=a(t,"IMG",{src:!0,width:!0}),qi=l(t),eo=a(t,"P",{});var iu=s(eo);ip=c(iu,"Prepare the conditioning:"),iu.forEach(n),Li=l(t),h(Mt.$$.fragment,t),Gi=l(t),Ft=a(t,"IMG",{src:!0,width:!0}),Ui=l(t),pe=a(t,"H3",{class:!0});var gr=s(pe);Te=a(gr,"A",{id:!0,class:!0,href:!0});var ru=s(Te);wa=a(ru,"SPAN",{});var lu=s(wa);h(qt.$$.fragment,lu),lu.forEach(n),ru.forEach(n),rp=l(gr),$a=a(gr,"SPAN",{});var pu=s($a);lp=c(pu,"Running ControlNet with multiple conditionings"),pu.forEach(n),gr.forEach(n),Oi=l(t),h(Lt.$$.fragment,t),zi=l(t),Gt=a(t,"IMG",{src:!0,width:!0}),Ri=l(t),ce=a(t,"H2",{class:!0});var _r=s(ce);Ie=a(_r,"A",{id:!0,class:!0,href:!0});var cu=s(Ie);xa=a(cu,"SPAN",{});var du=s(xa);h(Ut.$$.fragment,du),du.forEach(n),cu.forEach(n),pp=l(_r),Ea=a(_r,"SPAN",{});var fu=s(Ea);cp=c(fu,"Available checkpoints"),fu.forEach(n),_r.forEach(n),Hi=l(t),B=a(t,"P",{});var qo=s(B);dp=c(qo,"ControlNet requires a "),ka=a(qo,"EM",{});var mu=s(ka);fp=c(mu,"control image"),mu.forEach(n),mp=c(qo," in addition to the text-to-image "),Ca=a(qo,"EM",{});var uu=s(Ca);up=c(uu,"prompt"),uu.forEach(n),hp=c(qo,`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),qo.forEach(n),Wi=l(t),Ae=a(t,"P",{});var vr=s(Ae);gp=c(vr,"All checkpoints can be found under the authors\u2019 namespace "),Ot=a(vr,"A",{href:!0,rel:!0});var hu=s(Ot);_p=c(hu,"lllyasviel"),hu.forEach(n),vp=c(vr,"."),vr.forEach(n),Vi=l(t),de=a(t,"H3",{class:!0});var br=s(de);Me=a(br,"A",{id:!0,class:!0,href:!0});var gu=s(Me);Pa=a(gu,"SPAN",{});var _u=s(Pa);h(zt.$$.fragment,_u),_u.forEach(n),gu.forEach(n),bp=l(br),ja=a(br,"SPAN",{});var vu=s(ja);yp=c(vu,"ControlNet with Stable Diffusion 1.5"),vu.forEach(n),br.forEach(n),Bi=l(t),Fe=a(t,"TABLE",{});var yr=s(Fe);Da=a(yr,"THEAD",{});var bu=s(Da);q=a(bu,"TR",{});var tt=s(q);Na=a(tt,"TH",{});var yu=s(Na);wp=c(yu,"Model Name"),yu.forEach(n),$p=l(tt),Sa=a(tt,"TH",{});var wu=s(Sa);xp=c(wu,"Control Image Overview"),wu.forEach(n),Ep=l(tt),Ta=a(tt,"TH",{});var $u=s(Ta);kp=c($u,"Control Image Example"),$u.forEach(n),Cp=l(tt),Ia=a(tt,"TH",{});var xu=s(Ia);Pp=c(xu,"Generated Image Example"),xu.forEach(n),tt.forEach(n),bu.forEach(n),jp=l(yr),j=a(yr,"TBODY",{});var N=s(j);L=a(N,"TR",{});var nt=s(L);qe=a(nt,"TD",{});var qs=s(qe);Rt=a(qs,"A",{href:!0,rel:!0});var Eu=s(Rt);Dp=c(Eu,"lllyasviel/sd-controlnet-canny"),Eu.forEach(n),Np=a(qs,"BR",{}),Sp=l(qs),Aa=a(qs,"EM",{});var ku=s(Aa);Tp=c(ku,"Trained with canny edge detection"),ku.forEach(n),qs.forEach(n),Ip=l(nt),Ma=a(nt,"TD",{});var Cu=s(Ma);Ap=c(Cu,"A monochrome image with white edges on a black background."),Cu.forEach(n),Mp=l(nt),Fa=a(nt,"TD",{});var Pu=s(Fa);to=a(Pu,"A",{href:!0});var ju=s(to);Le=a(ju,"IMG",{width:!0,style:!0,src:!0}),ju.forEach(n),Pu.forEach(n),Fp=l(nt),qa=a(nt,"TD",{});var Du=s(qa);no=a(Du,"A",{href:!0});var Nu=s(no);oo=a(Nu,"IMG",{width:!0,src:!0}),Nu.forEach(n),Du.forEach(n),nt.forEach(n),qp=l(N),G=a(N,"TR",{});var ot=s(G);Ge=a(ot,"TD",{});var Ls=s(Ge);Ht=a(Ls,"A",{href:!0,rel:!0});var Su=s(Ht);Lp=c(Su,"lllyasviel/sd-controlnet-depth"),Su.forEach(n),Gp=a(Ls,"BR",{}),Up=l(Ls),La=a(Ls,"EM",{});var Tu=s(La);Op=c(Tu,"Trained with Midas depth estimation"),Tu.forEach(n),Ls.forEach(n),zp=l(ot),Ga=a(ot,"TD",{});var Iu=s(Ga);Rp=c(Iu,"A grayscale image with black representing deep areas and white representing shallow areas."),Iu.forEach(n),Hp=l(ot),Ua=a(ot,"TD",{});var Au=s(Ua);ao=a(Au,"A",{href:!0});var Mu=s(ao);so=a(Mu,"IMG",{width:!0,src:!0}),Mu.forEach(n),Au.forEach(n),Wp=l(ot),Oa=a(ot,"TD",{});var Fu=s(Oa);io=a(Fu,"A",{href:!0});var qu=s(io);ro=a(qu,"IMG",{width:!0,src:!0}),qu.forEach(n),Fu.forEach(n),ot.forEach(n),Vp=l(N),U=a(N,"TR",{});var at=s(U);Ue=a(at,"TD",{});var Gs=s(Ue);Wt=a(Gs,"A",{href:!0,rel:!0});var Lu=s(Wt);Bp=c(Lu,"lllyasviel/sd-controlnet-hed"),Lu.forEach(n),Kp=a(Gs,"BR",{}),Yp=l(Gs),za=a(Gs,"EM",{});var Gu=s(za);Xp=c(Gu,"Trained with HED edge detection (soft edge)"),Gu.forEach(n),Gs.forEach(n),Zp=l(at),Ra=a(at,"TD",{});var Uu=s(Ra);Jp=c(Uu,"A monochrome image with white soft edges on a black background."),Uu.forEach(n),Qp=l(at),Ha=a(at,"TD",{});var Ou=s(Ha);lo=a(Ou,"A",{href:!0});var zu=s(lo);po=a(zu,"IMG",{width:!0,src:!0}),zu.forEach(n),Ou.forEach(n),ec=l(at),Wa=a(at,"TD",{});var Ru=s(Wa);co=a(Ru,"A",{href:!0});var Hu=s(co);fo=a(Hu,"IMG",{width:!0,src:!0}),Hu.forEach(n),Ru.forEach(n),at.forEach(n),tc=l(N),O=a(N,"TR",{});var st=s(O);Oe=a(st,"TD",{});var Us=s(Oe);Vt=a(Us,"A",{href:!0,rel:!0});var Wu=s(Vt);nc=c(Wu,"lllyasviel/sd-controlnet-mlsd"),Wu.forEach(n),oc=a(Us,"BR",{}),ac=l(Us),Va=a(Us,"EM",{});var Vu=s(Va);sc=c(Vu,"Trained with M-LSD line detection"),Vu.forEach(n),Us.forEach(n),ic=l(st),Ba=a(st,"TD",{});var Bu=s(Ba);rc=c(Bu,"A monochrome image composed only of white straight lines on a black background."),Bu.forEach(n),lc=l(st),Ka=a(st,"TD",{});var Ku=s(Ka);mo=a(Ku,"A",{href:!0});var Yu=s(mo);uo=a(Yu,"IMG",{width:!0,src:!0}),Yu.forEach(n),Ku.forEach(n),pc=l(st),Ya=a(st,"TD",{});var Xu=s(Ya);ho=a(Xu,"A",{href:!0});var Zu=s(ho);go=a(Zu,"IMG",{width:!0,src:!0}),Zu.forEach(n),Xu.forEach(n),st.forEach(n),cc=l(N),z=a(N,"TR",{});var it=s(z);ze=a(it,"TD",{});var Os=s(ze);Bt=a(Os,"A",{href:!0,rel:!0});var Ju=s(Bt);dc=c(Ju,"lllyasviel/sd-controlnet-normal"),Ju.forEach(n),fc=a(Os,"BR",{}),mc=l(Os),Xa=a(Os,"EM",{});var Qu=s(Xa);uc=c(Qu,"Trained with normal map"),Qu.forEach(n),Os.forEach(n),hc=l(it),Kt=a(it,"TD",{});var wr=s(Kt);gc=c(wr,"A "),Yt=a(wr,"A",{href:!0,rel:!0});var eh=s(Yt);_c=c(eh,"normal mapped"),eh.forEach(n),vc=c(wr," image."),wr.forEach(n),bc=l(it),Za=a(it,"TD",{});var th=s(Za);_o=a(th,"A",{href:!0});var nh=s(_o);vo=a(nh,"IMG",{width:!0,src:!0}),nh.forEach(n),th.forEach(n),yc=l(it),Ja=a(it,"TD",{});var oh=s(Ja);bo=a(oh,"A",{href:!0});var ah=s(bo);yo=a(ah,"IMG",{width:!0,src:!0}),ah.forEach(n),oh.forEach(n),it.forEach(n),wc=l(N),R=a(N,"TR",{});var rt=s(R);Re=a(rt,"TD",{});var zs=s(Re);Xt=a(zs,"A",{href:!0,rel:!0});var sh=s(Xt);$c=c(sh,"lllyasviel/sd-controlnet-openpose"),sh.forEach(n),xc=a(zs,"BR",{}),Ec=l(zs),Qa=a(zs,"EM",{});var ih=s(Qa);kc=c(ih,"Trained with OpenPose bone image"),ih.forEach(n),zs.forEach(n),Cc=l(rt),Zt=a(rt,"TD",{});var $r=s(Zt);Pc=c($r,"A "),Jt=a($r,"A",{href:!0,rel:!0});var rh=s(Jt);jc=c(rh,"OpenPose bone"),rh.forEach(n),Dc=c($r," image."),$r.forEach(n),Nc=l(rt),es=a(rt,"TD",{});var lh=s(es);wo=a(lh,"A",{href:!0});var ph=s(wo);$o=a(ph,"IMG",{width:!0,src:!0}),ph.forEach(n),lh.forEach(n),Sc=l(rt),ts=a(rt,"TD",{});var ch=s(ts);xo=a(ch,"A",{href:!0});var dh=s(xo);Eo=a(dh,"IMG",{width:!0,src:!0}),dh.forEach(n),ch.forEach(n),rt.forEach(n),Tc=l(N),H=a(N,"TR",{});var lt=s(H);He=a(lt,"TD",{});var Rs=s(He);Qt=a(Rs,"A",{href:!0,rel:!0});var fh=s(Qt);Ic=c(fh,"lllyasviel/sd-controlnet-scribble"),fh.forEach(n),Ac=a(Rs,"BR",{}),Mc=l(Rs),ns=a(Rs,"EM",{});var mh=s(ns);Fc=c(mh,"Trained with human scribbles"),mh.forEach(n),Rs.forEach(n),qc=l(lt),os=a(lt,"TD",{});var uh=s(os);Lc=c(uh,"A hand-drawn monochrome image with white outlines on a black background."),uh.forEach(n),Gc=l(lt),as=a(lt,"TD",{});var hh=s(as);ko=a(hh,"A",{href:!0});var gh=s(ko);Co=a(gh,"IMG",{width:!0,src:!0}),gh.forEach(n),hh.forEach(n),Uc=l(lt),ss=a(lt,"TD",{});var _h=s(ss);Po=a(_h,"A",{href:!0});var vh=s(Po);jo=a(vh,"IMG",{width:!0,src:!0}),vh.forEach(n),_h.forEach(n),lt.forEach(n),Oc=l(N),W=a(N,"TR",{});var pt=s(W);en=a(pt,"TD",{});var xr=s(en);tn=a(xr,"A",{href:!0,rel:!0});var bh=s(tn);zc=c(bh,"lllyasviel/sd-controlnet-seg"),bh.forEach(n),Rc=a(xr,"BR",{}),is=a(xr,"EM",{});var yh=s(is);Hc=c(yh,"Trained with semantic segmentation"),yh.forEach(n),xr.forEach(n),Wc=l(pt),nn=a(pt,"TD",{});var Er=s(nn);Vc=c(Er,"An "),on=a(Er,"A",{href:!0,rel:!0});var wh=s(on);Bc=c(wh,"ADE20K"),wh.forEach(n),Kc=c(Er,"\u2019s segmentation protocol image."),Er.forEach(n),Yc=l(pt),rs=a(pt,"TD",{});var $h=s(rs);Do=a($h,"A",{href:!0});var xh=s(Do);No=a(xh,"IMG",{width:!0,src:!0}),xh.forEach(n),$h.forEach(n),Xc=l(pt),ls=a(pt,"TD",{});var Eh=s(ls);So=a(Eh,"A",{href:!0});var kh=s(So);To=a(kh,"IMG",{width:!0,src:!0}),kh.forEach(n),Eh.forEach(n),pt.forEach(n),N.forEach(n),yr.forEach(n),Ki=l(t),fe=a(t,"H2",{class:!0});var kr=s(fe);We=a(kr,"A",{id:!0,class:!0,href:!0});var Ch=s(We);ps=a(Ch,"SPAN",{});var Ph=s(ps);h(an.$$.fragment,Ph),Ph.forEach(n),Ch.forEach(n),Zc=l(kr),cs=a(kr,"SPAN",{});var jh=s(cs);Jc=c(jh,"StableDiffusionControlNetPipeline"),jh.forEach(n),kr.forEach(n),Yi=l(t),$=a(t,"DIV",{class:!0});var k=s($);h(sn.$$.fragment,k),Qc=l(k),ds=a(k,"P",{});var Dh=s(ds);ed=c(Dh,"Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),Dh.forEach(n),td=l(k),rn=a(k,"P",{});var Cr=s(rn);nd=c(Cr,"This model inherits from "),Io=a(Cr,"A",{href:!0});var Nh=s(Io);od=c(Nh,"DiffusionPipeline"),Nh.forEach(n),ad=c(Cr,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Cr.forEach(n),sd=l(k),K=a(k,"DIV",{class:!0});var Lo=s(K);h(ln.$$.fragment,Lo),id=l(Lo),fs=a(Lo,"P",{});var Sh=s(fs);rd=c(Sh,"Function invoked when calling the pipeline for generation."),Sh.forEach(n),ld=l(Lo),h(Ve.$$.fragment,Lo),Lo.forEach(n),pd=l(k),Y=a(k,"DIV",{class:!0});var Go=s(Y);h(pn.$$.fragment,Go),cd=l(Go),ms=a(Go,"P",{});var Th=s(ms);dd=c(Th,"Enable sliced attention computation."),Th.forEach(n),fd=l(Go),us=a(Go,"P",{});var Ih=s(us);md=c(Ih,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Ih.forEach(n),Go.forEach(n),ud=l(k),Be=a(k,"DIV",{class:!0});var Pr=s(Be);h(cn.$$.fragment,Pr),hd=l(Pr),dn=a(Pr,"P",{});var jr=s(dn);gd=c(jr,"Disable sliced attention computation. If "),hs=a(jr,"CODE",{});var Ah=s(hs);_d=c(Ah,"enable_attention_slicing"),Ah.forEach(n),vd=c(jr,` was previously invoked, this method will go
back to computing attention in one step.`),jr.forEach(n),Pr.forEach(n),bd=l(k),X=a(k,"DIV",{class:!0});var Uo=s(X);h(fn.$$.fragment,Uo),yd=l(Uo),gs=a(Uo,"P",{});var Mh=s(gs);wd=c(Mh,"Enable sliced VAE decoding."),Mh.forEach(n),$d=l(Uo),_s=a(Uo,"P",{});var Fh=s(_s);xd=c(Fh,`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),Fh.forEach(n),Uo.forEach(n),Ed=l(k),Ke=a(k,"DIV",{class:!0});var Dr=s(Ke);h(mn.$$.fragment,Dr),kd=l(Dr),un=a(Dr,"P",{});var Nr=s(un);Cd=c(Nr,"Disable sliced VAE decoding. If "),vs=a(Nr,"CODE",{});var qh=s(vs);Pd=c(qh,"enable_vae_slicing"),qh.forEach(n),jd=c(Nr,` was previously invoked, this method will go back to
computing decoding in one step.`),Nr.forEach(n),Dr.forEach(n),Dd=l(k),S=a(k,"DIV",{class:!0});var J=s(S);h(hn.$$.fragment,J),Nd=l(J),bs=a(J,"P",{});var Lh=s(bs);Sd=c(Lh,"Enable memory efficient attention as implemented in xformers."),Lh.forEach(n),Td=l(J),ys=a(J,"P",{});var Gh=s(ys);Id=c(Gh,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Gh.forEach(n),Ad=l(J),ws=a(J,"P",{});var Uh=s(ws);Md=c(Uh,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Uh.forEach(n),Fd=l(J),h(Ye.$$.fragment,J),J.forEach(n),qd=l(k),Xe=a(k,"DIV",{class:!0});var Sr=s(Xe);h(gn.$$.fragment,Sr),Ld=l(Sr),$s=a(Sr,"P",{});var Oh=s($s);Gd=c(Oh,"Disable memory efficient attention as implemented in xformers."),Oh.forEach(n),Sr.forEach(n),Ud=l(k),Ze=a(k,"DIV",{class:!0});var Tr=s(Ze);h(_n.$$.fragment,Tr),Od=l(Tr),T=a(Tr,"P",{});var Q=s(T);zd=c(Q,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),xs=a(Q,"CODE",{});var zh=s(xs);Rd=c(zh,"enable_sequential_cpu_offload"),zh.forEach(n),Hd=c(Q,", this method moves one whole model at a time to the GPU when its "),Es=a(Q,"CODE",{});var Rh=s(Es);Wd=c(Rh,"forward"),Rh.forEach(n),Vd=c(Q,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),ks=a(Q,"CODE",{});var Hh=s(ks);Bd=c(Hh,"enable_sequential_cpu_offload"),Hh.forEach(n),Kd=c(Q,", but performance is much better due to the iterative execution of the "),Cs=a(Q,"CODE",{});var Wh=s(Cs);Yd=c(Wh,"unet"),Wh.forEach(n),Xd=c(Q,"."),Q.forEach(n),Tr.forEach(n),Zd=l(k),Je=a(k,"DIV",{class:!0});var Ir=s(Je);h(vn.$$.fragment,Ir),Jd=l(Ir),me=a(Ir,"P",{});var Oo=s(me);Qd=c(Oo,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),Ps=a(Oo,"CODE",{});var Vh=s(Ps);ef=c(Vh,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),Vh.forEach(n),tf=c(Oo,"forward"),js=a(Oo,"CODE",{});var Bh=s(js);nf=c(Bh,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),Bh.forEach(n),of=c(Oo,"enable_model_cpu_offload`, but performance is lower."),Oo.forEach(n),Ir.forEach(n),k.forEach(n),Xi=l(t),ue=a(t,"H2",{class:!0});var Ar=s(ue);Qe=a(Ar,"A",{id:!0,class:!0,href:!0});var Kh=s(Qe);Ds=a(Kh,"SPAN",{});var Yh=s(Ds);h(bn.$$.fragment,Yh),Yh.forEach(n),Kh.forEach(n),af=l(Ar),Ns=a(Ar,"SPAN",{});var Xh=s(Ns);sf=c(Xh,"FlaxStableDiffusionControlNetPipeline"),Xh.forEach(n),Ar.forEach(n),Zi=l(t),I=a(t,"DIV",{class:!0});var ct=s(I);h(yn.$$.fragment,ct),rf=l(ct),Ss=a(ct,"P",{});var Zh=s(Ss);lf=c(Zh,"Pipeline for text-to-image generation using Stable Diffusion with ControlNet Guidance."),Zh.forEach(n),pf=l(ct),wn=a(ct,"P",{});var Mr=s(wn);cf=c(Mr,"This model inherits from "),Ts=a(Mr,"CODE",{});var Jh=s(Ts);df=c(Jh,"FlaxDiffusionPipeline"),Jh.forEach(n),ff=c(Mr,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Mr.forEach(n),mf=l(ct),Z=a(ct,"DIV",{class:!0});var zo=s(Z);h($n.$$.fragment,zo),uf=l(zo),Is=a(zo,"P",{});var Qh=s(Is);hf=c(Qh,"Function invoked when calling the pipeline for generation."),Qh.forEach(n),gf=l(zo),h(et.$$.fragment,zo),zo.forEach(n),ct.forEach(n),this.h()},h(){i(w,"name","hf:doc:metadata"),i(w,"content",JSON.stringify(cg)),i(y,"id","texttoimage-generation-with-controlnet-conditioning"),i(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(y,"href","#texttoimage-generation-with-controlnet-conditioning"),i(x,"class","relative group"),i(ge,"id","overview"),i(ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(ge,"href","#overview"),i(ee,"class","relative group"),i(mt,"href","https://arxiv.org/abs/2302.05543"),i(mt,"rel","nofollow"),i(ut,"href","https://huggingface.co/takuma104"),i(ut,"rel","nofollow"),i(ht,"href","https://arxiv.org/abs/2302.05543"),i(ht,"rel","nofollow"),i(gt,"href","https://github.com/lllyasviel/ControlNet"),i(gt,"rel","nofollow"),i(be,"id","available-pipelines"),i(be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(be,"href","#available-pipelines"),i(te,"class","relative group"),i(jn,"align","center"),i(vt,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py"),i(vt,"rel","nofollow"),i(bt,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers/controlnet.ipynb"),i(bt,"rel","nofollow"),i(Dn,"align","center"),i(we,"id","usage-example"),i(we,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(we,"href","#usage-example"),i(ae,"class","relative group"),i(Sn,"href","/docs/diffusers/pr_2945/en/api/pipelines/stable_diffusion/controlnet#diffusers.StableDiffusionControlNetPipeline"),i(Nn,"start","2"),i($t,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),i($t,"rel","nofollow"),C(In.src,yf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png")||i(In,"src",yf),i(In,"alt","img"),i(An,"href","#controlnet-with-stable-diffusion-1.5"),C(Un.src,wf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_canny_edged.png")||i(Un,"src",wf),i(Un,"alt","img"),i(On,"href","runwayml/stable-diffusion-v1-5"),i(zn,"href","/docs/diffusers/pr_2945/en/api/schedulers/unipc#diffusers.UniPCMultistepScheduler"),C(Vn.src,$f="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_disco_dancing.png")||i(Vn,"src",$f),i(Vn,"alt","img"),i(Bn,"href","#controlnet-with-stable-diffusion-1.5"),i(Pe,"id","combining-multiple-conditionings"),i(Pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Pe,"href","#combining-multiple-conditionings"),i(ie,"class","relative group"),i(Ne,"id","canny-conditioning"),i(Ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ne,"href","#canny-conditioning"),i(re,"class","relative group"),C(Xn.src,xf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/landscape.png")||i(Xn,"src",xf),C(Jn.src,Ef="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/landscape_canny_masked.png")||i(Jn,"src",Ef),i(Se,"id","openpose-conditioning"),i(Se,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Se,"href","#openpose-conditioning"),i(le,"class","relative group"),C(At.src,kf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/person.png")||i(At,"src",kf),i(At,"width","600"),C(Ft.src,Cf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/person_pose.png")||i(Ft,"src",Cf),i(Ft,"width","600"),i(Te,"id","running-controlnet-with-multiple-conditionings"),i(Te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Te,"href","#running-controlnet-with-multiple-conditionings"),i(pe,"class","relative group"),C(Gt.src,Pf="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/blog/controlnet/multi_controlnet_output.png")||i(Gt,"src",Pf),i(Gt,"width","600"),i(Ie,"id","available-checkpoints"),i(Ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Ie,"href","#available-checkpoints"),i(ce,"class","relative group"),i(Ot,"href","https://huggingface.co/lllyasviel"),i(Ot,"rel","nofollow"),i(Me,"id","controlnet-with-stable-diffusion-15"),i(Me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Me,"href","#controlnet-with-stable-diffusion-15"),i(de,"class","relative group"),i(Rt,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),i(Rt,"rel","nofollow"),i(Le,"width","64"),eg(Le,"margin","0"),eg(Le,"padding","0"),C(Le.src,jf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_canny.png")||i(Le,"src",jf),i(to,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_canny.png"),i(oo,"width","64"),C(oo.src,Df="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png")||i(oo,"src",Df),i(no,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png"),i(Ht,"href","https://huggingface.co/lllyasviel/sd-controlnet-depth"),i(Ht,"rel","nofollow"),i(so,"width","64"),C(so.src,Nf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_depth.png")||i(so,"src",Nf),i(ao,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_depth.png"),i(ro,"width","64"),C(ro.src,Sf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png")||i(ro,"src",Sf),i(io,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png"),i(Wt,"href","https://huggingface.co/lllyasviel/sd-controlnet-hed"),i(Wt,"rel","nofollow"),i(po,"width","64"),C(po.src,Tf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_hed.png")||i(po,"src",Tf),i(lo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_hed.png"),i(fo,"width","64"),C(fo.src,If="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png")||i(fo,"src",If),i(co,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png"),i(Vt,"href","https://huggingface.co/lllyasviel/sd-controlnet-mlsd"),i(Vt,"rel","nofollow"),i(uo,"width","64"),C(uo.src,Af="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_mlsd.png")||i(uo,"src",Af),i(mo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_mlsd.png"),i(go,"width","64"),C(go.src,Mf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png")||i(go,"src",Mf),i(ho,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png"),i(Bt,"href","https://huggingface.co/lllyasviel/sd-controlnet-normal"),i(Bt,"rel","nofollow"),i(Yt,"href","https://en.wikipedia.org/wiki/Normal_mapping"),i(Yt,"rel","nofollow"),i(vo,"width","64"),C(vo.src,Ff="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_normal.png")||i(vo,"src",Ff),i(_o,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_normal.png"),i(yo,"width","64"),C(yo.src,qf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png")||i(yo,"src",qf),i(bo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png"),i(Xt,"href","https://huggingface.co/lllyasviel/sd-controlnet_openpose"),i(Xt,"rel","nofollow"),i(Jt,"href","https://github.com/CMU-Perceptual-Computing-Lab/openpose"),i(Jt,"rel","nofollow"),i($o,"width","64"),C($o.src,Lf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_openpose.png")||i($o,"src",Lf),i(wo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_openpose.png"),i(Eo,"width","64"),C(Eo.src,Gf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png")||i(Eo,"src",Gf),i(xo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png"),i(Qt,"href","https://huggingface.co/lllyasviel/sd-controlnet_scribble"),i(Qt,"rel","nofollow"),i(Co,"width","64"),C(Co.src,Uf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_scribble.png")||i(Co,"src",Uf),i(ko,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_scribble.png"),i(jo,"width","64"),C(jo.src,Of="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png")||i(jo,"src",Of),i(Po,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png"),i(tn,"href","https://huggingface.co/lllyasviel/sd-controlnet_seg"),i(tn,"rel","nofollow"),i(on,"href","https://groups.csail.mit.edu/vision/datasets/ADE20K/"),i(on,"rel","nofollow"),i(No,"width","64"),C(No.src,zf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_seg.png")||i(No,"src",zf),i(Do,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_seg.png"),i(To,"width","64"),C(To.src,Rf="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png")||i(To,"src",Rf),i(So,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png"),i(We,"id","diffusers.StableDiffusionControlNetPipeline"),i(We,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(We,"href","#diffusers.StableDiffusionControlNetPipeline"),i(fe,"class","relative group"),i(Io,"href","/docs/diffusers/pr_2945/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),i(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(Qe,"id","diffusers.FlaxStableDiffusionControlNetPipeline"),i(Qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(Qe,"href","#diffusers.FlaxStableDiffusionControlNetPipeline"),i(ue,"class","relative group"),i(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),i(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,d){e(document.head,w),f(t,D,d),f(t,x,d),e(x,y),e(y,P),g(m,P,null),e(x,E),e(x,Ro),e(Ro,Fr),f(t,Hs,d),f(t,ee,d),e(ee,ge),e(ge,Ho),g(dt,Ho,null),e(ee,qr),e(ee,Wo),e(Wo,Lr),f(t,Ws,d),f(t,ft,d),e(ft,mt),e(mt,Gr),e(ft,Ur),f(t,Vs,d),f(t,En,d),e(En,Or),f(t,Bs,d),f(t,kn,d),e(kn,zr),f(t,Ks,d),f(t,Cn,d),e(Cn,Vo),e(Vo,Rr),f(t,Ys,d),f(t,_e,d),e(_e,Hr),e(_e,ut),e(ut,Wr),e(_e,Vr),f(t,Xs,d),f(t,Pn,d),e(Pn,Br),f(t,Zs,d),f(t,ve,d),e(ve,Bo),e(Bo,ht),e(ht,Kr),e(ve,Yr),e(ve,Ko),e(Ko,gt),e(gt,Xr),f(t,Js,d),f(t,te,d),e(te,be),e(be,Yo),g(_t,Yo,null),e(te,Zr),e(te,Xo),e(Xo,Jr),f(t,Qs,d),f(t,ye,d),e(ye,Zo),e(Zo,ne),e(ne,Jo),e(Jo,Qr),e(ne,el),e(ne,Qo),e(Qo,tl),e(ne,nl),e(ne,jn),e(jn,ol),e(ye,al),e(ye,ea),e(ea,oe),e(oe,ta),e(ta,vt),e(vt,sl),e(oe,il),e(oe,na),e(na,oa),e(oa,rl),e(oe,ll),e(oe,Dn),e(Dn,bt),e(bt,pl),f(t,ei,d),f(t,ae,d),e(ae,we),e(we,aa),g(yt,aa,null),e(ae,cl),e(ae,sa),e(sa,dl),f(t,ti,d),f(t,$e,d),e($e,fl),e($e,ia),e(ia,ml),e($e,ul),f(t,ni,d),f(t,xe,d),e(xe,ra),e(ra,la),e(la,pa),e(pa,hl),e(xe,gl),e(xe,ca),e(ca,Nn),e(Nn,wt),e(wt,_l),e(wt,Sn),e(Sn,vl),e(wt,bl),f(t,oi,d),f(t,Ee,d),e(Ee,yl),e(Ee,$t),e($t,wl),e(Ee,$l),f(t,ai,d),g(xt,t,d),f(t,si,d),f(t,Tn,d),e(Tn,In),f(t,ii,d),f(t,V,d),e(V,xl),e(V,da),e(da,El),e(V,kl),e(V,An),e(An,Cl),e(V,Pl),f(t,ri,d),f(t,Mn,d),e(Mn,jl),f(t,li,d),g(Et,t,d),f(t,pi,d),f(t,Fn,d),e(Fn,Dl),f(t,ci,d),g(kt,t,d),f(t,di,d),f(t,qn,d),e(qn,Nl),f(t,fi,d),g(Ct,t,d),f(t,mi,d),f(t,Ln,d),e(Ln,Sl),f(t,ui,d),f(t,Gn,d),e(Gn,Un),f(t,hi,d),f(t,ke,d),e(ke,Tl),e(ke,On),e(On,Il),e(ke,Al),f(t,gi,d),g(Pt,t,d),f(t,_i,d),f(t,Ce,d),e(Ce,Ml),e(Ce,zn),e(zn,Fl),e(Ce,ql),f(t,vi,d),g(jt,t,d),f(t,bi,d),f(t,Rn,d),e(Rn,Ll),f(t,yi,d),g(Dt,t,d),f(t,wi,d),f(t,Hn,d),e(Hn,Gl),f(t,$i,d),f(t,Wn,d),e(Wn,Vn),f(t,xi,d),f(t,se,d),e(se,fa),e(fa,Ul),e(se,Ol),e(se,Bn),e(Bn,zl),e(se,Rl),f(t,Ei,d),f(t,ie,d),e(ie,Pe),e(Pe,ma),g(Nt,ma,null),e(ie,Hl),e(ie,ua),e(ua,Wl),f(t,ki,d),f(t,je,d),e(je,Vl),e(je,ha),e(ha,Bl),e(je,Kl),f(t,Ci,d),f(t,Kn,d),e(Kn,Yl),f(t,Pi,d),f(t,De,d),e(De,Xl),e(De,ga),e(ga,Zl),e(De,Jl),f(t,ji,d),f(t,re,d),e(re,Ne),e(Ne,_a),g(St,_a,null),e(re,Ql),e(re,va),e(va,ep),f(t,Di,d),f(t,Yn,d),e(Yn,tp),f(t,Ni,d),f(t,Xn,d),f(t,Si,d),f(t,Zn,d),e(Zn,np),f(t,Ti,d),g(Tt,t,d),f(t,Ii,d),f(t,Jn,d),f(t,Ai,d),f(t,le,d),e(le,Se),e(Se,ba),g(It,ba,null),e(le,op),e(le,ya),e(ya,ap),f(t,Mi,d),f(t,Qn,d),e(Qn,sp),f(t,Fi,d),f(t,At,d),f(t,qi,d),f(t,eo,d),e(eo,ip),f(t,Li,d),g(Mt,t,d),f(t,Gi,d),f(t,Ft,d),f(t,Ui,d),f(t,pe,d),e(pe,Te),e(Te,wa),g(qt,wa,null),e(pe,rp),e(pe,$a),e($a,lp),f(t,Oi,d),g(Lt,t,d),f(t,zi,d),f(t,Gt,d),f(t,Ri,d),f(t,ce,d),e(ce,Ie),e(Ie,xa),g(Ut,xa,null),e(ce,pp),e(ce,Ea),e(Ea,cp),f(t,Hi,d),f(t,B,d),e(B,dp),e(B,ka),e(ka,fp),e(B,mp),e(B,Ca),e(Ca,up),e(B,hp),f(t,Wi,d),f(t,Ae,d),e(Ae,gp),e(Ae,Ot),e(Ot,_p),e(Ae,vp),f(t,Vi,d),f(t,de,d),e(de,Me),e(Me,Pa),g(zt,Pa,null),e(de,bp),e(de,ja),e(ja,yp),f(t,Bi,d),f(t,Fe,d),e(Fe,Da),e(Da,q),e(q,Na),e(Na,wp),e(q,$p),e(q,Sa),e(Sa,xp),e(q,Ep),e(q,Ta),e(Ta,kp),e(q,Cp),e(q,Ia),e(Ia,Pp),e(Fe,jp),e(Fe,j),e(j,L),e(L,qe),e(qe,Rt),e(Rt,Dp),e(qe,Np),e(qe,Sp),e(qe,Aa),e(Aa,Tp),e(L,Ip),e(L,Ma),e(Ma,Ap),e(L,Mp),e(L,Fa),e(Fa,to),e(to,Le),e(L,Fp),e(L,qa),e(qa,no),e(no,oo),e(j,qp),e(j,G),e(G,Ge),e(Ge,Ht),e(Ht,Lp),e(Ge,Gp),e(Ge,Up),e(Ge,La),e(La,Op),e(G,zp),e(G,Ga),e(Ga,Rp),e(G,Hp),e(G,Ua),e(Ua,ao),e(ao,so),e(G,Wp),e(G,Oa),e(Oa,io),e(io,ro),e(j,Vp),e(j,U),e(U,Ue),e(Ue,Wt),e(Wt,Bp),e(Ue,Kp),e(Ue,Yp),e(Ue,za),e(za,Xp),e(U,Zp),e(U,Ra),e(Ra,Jp),e(U,Qp),e(U,Ha),e(Ha,lo),e(lo,po),e(U,ec),e(U,Wa),e(Wa,co),e(co,fo),e(j,tc),e(j,O),e(O,Oe),e(Oe,Vt),e(Vt,nc),e(Oe,oc),e(Oe,ac),e(Oe,Va),e(Va,sc),e(O,ic),e(O,Ba),e(Ba,rc),e(O,lc),e(O,Ka),e(Ka,mo),e(mo,uo),e(O,pc),e(O,Ya),e(Ya,ho),e(ho,go),e(j,cc),e(j,z),e(z,ze),e(ze,Bt),e(Bt,dc),e(ze,fc),e(ze,mc),e(ze,Xa),e(Xa,uc),e(z,hc),e(z,Kt),e(Kt,gc),e(Kt,Yt),e(Yt,_c),e(Kt,vc),e(z,bc),e(z,Za),e(Za,_o),e(_o,vo),e(z,yc),e(z,Ja),e(Ja,bo),e(bo,yo),e(j,wc),e(j,R),e(R,Re),e(Re,Xt),e(Xt,$c),e(Re,xc),e(Re,Ec),e(Re,Qa),e(Qa,kc),e(R,Cc),e(R,Zt),e(Zt,Pc),e(Zt,Jt),e(Jt,jc),e(Zt,Dc),e(R,Nc),e(R,es),e(es,wo),e(wo,$o),e(R,Sc),e(R,ts),e(ts,xo),e(xo,Eo),e(j,Tc),e(j,H),e(H,He),e(He,Qt),e(Qt,Ic),e(He,Ac),e(He,Mc),e(He,ns),e(ns,Fc),e(H,qc),e(H,os),e(os,Lc),e(H,Gc),e(H,as),e(as,ko),e(ko,Co),e(H,Uc),e(H,ss),e(ss,Po),e(Po,jo),e(j,Oc),e(j,W),e(W,en),e(en,tn),e(tn,zc),e(en,Rc),e(en,is),e(is,Hc),e(W,Wc),e(W,nn),e(nn,Vc),e(nn,on),e(on,Bc),e(nn,Kc),e(W,Yc),e(W,rs),e(rs,Do),e(Do,No),e(W,Xc),e(W,ls),e(ls,So),e(So,To),f(t,Ki,d),f(t,fe,d),e(fe,We),e(We,ps),g(an,ps,null),e(fe,Zc),e(fe,cs),e(cs,Jc),f(t,Yi,d),f(t,$,d),g(sn,$,null),e($,Qc),e($,ds),e(ds,ed),e($,td),e($,rn),e(rn,nd),e(rn,Io),e(Io,od),e(rn,ad),e($,sd),e($,K),g(ln,K,null),e(K,id),e(K,fs),e(fs,rd),e(K,ld),g(Ve,K,null),e($,pd),e($,Y),g(pn,Y,null),e(Y,cd),e(Y,ms),e(ms,dd),e(Y,fd),e(Y,us),e(us,md),e($,ud),e($,Be),g(cn,Be,null),e(Be,hd),e(Be,dn),e(dn,gd),e(dn,hs),e(hs,_d),e(dn,vd),e($,bd),e($,X),g(fn,X,null),e(X,yd),e(X,gs),e(gs,wd),e(X,$d),e(X,_s),e(_s,xd),e($,Ed),e($,Ke),g(mn,Ke,null),e(Ke,kd),e(Ke,un),e(un,Cd),e(un,vs),e(vs,Pd),e(un,jd),e($,Dd),e($,S),g(hn,S,null),e(S,Nd),e(S,bs),e(bs,Sd),e(S,Td),e(S,ys),e(ys,Id),e(S,Ad),e(S,ws),e(ws,Md),e(S,Fd),g(Ye,S,null),e($,qd),e($,Xe),g(gn,Xe,null),e(Xe,Ld),e(Xe,$s),e($s,Gd),e($,Ud),e($,Ze),g(_n,Ze,null),e(Ze,Od),e(Ze,T),e(T,zd),e(T,xs),e(xs,Rd),e(T,Hd),e(T,Es),e(Es,Wd),e(T,Vd),e(T,ks),e(ks,Bd),e(T,Kd),e(T,Cs),e(Cs,Yd),e(T,Xd),e($,Zd),e($,Je),g(vn,Je,null),e(Je,Jd),e(Je,me),e(me,Qd),e(me,Ps),e(Ps,ef),e(me,tf),e(me,js),e(js,nf),e(me,of),f(t,Xi,d),f(t,ue,d),e(ue,Qe),e(Qe,Ds),g(bn,Ds,null),e(ue,af),e(ue,Ns),e(Ns,sf),f(t,Zi,d),f(t,I,d),g(yn,I,null),e(I,rf),e(I,Ss),e(Ss,lf),e(I,pf),e(I,wn),e(wn,cf),e(wn,Ts),e(Ts,df),e(wn,ff),e(I,mf),e(I,Z),g($n,Z,null),e(Z,uf),e(Z,Is),e(Is,hf),e(Z,gf),g(et,Z,null),Ji=!0},p(t,[d]){const xn={};d&2&&(xn.$$scope={dirty:d,ctx:t}),Ve.$set(xn);const As={};d&2&&(As.$$scope={dirty:d,ctx:t}),Ye.$set(As);const Ms={};d&2&&(Ms.$$scope={dirty:d,ctx:t}),et.$set(Ms)},i(t){Ji||(_(m.$$.fragment,t),_(dt.$$.fragment,t),_(_t.$$.fragment,t),_(yt.$$.fragment,t),_(xt.$$.fragment,t),_(Et.$$.fragment,t),_(kt.$$.fragment,t),_(Ct.$$.fragment,t),_(Pt.$$.fragment,t),_(jt.$$.fragment,t),_(Dt.$$.fragment,t),_(Nt.$$.fragment,t),_(St.$$.fragment,t),_(Tt.$$.fragment,t),_(It.$$.fragment,t),_(Mt.$$.fragment,t),_(qt.$$.fragment,t),_(Lt.$$.fragment,t),_(Ut.$$.fragment,t),_(zt.$$.fragment,t),_(an.$$.fragment,t),_(sn.$$.fragment,t),_(ln.$$.fragment,t),_(Ve.$$.fragment,t),_(pn.$$.fragment,t),_(cn.$$.fragment,t),_(fn.$$.fragment,t),_(mn.$$.fragment,t),_(hn.$$.fragment,t),_(Ye.$$.fragment,t),_(gn.$$.fragment,t),_(_n.$$.fragment,t),_(vn.$$.fragment,t),_(bn.$$.fragment,t),_(yn.$$.fragment,t),_($n.$$.fragment,t),_(et.$$.fragment,t),Ji=!0)},o(t){v(m.$$.fragment,t),v(dt.$$.fragment,t),v(_t.$$.fragment,t),v(yt.$$.fragment,t),v(xt.$$.fragment,t),v(Et.$$.fragment,t),v(kt.$$.fragment,t),v(Ct.$$.fragment,t),v(Pt.$$.fragment,t),v(jt.$$.fragment,t),v(Dt.$$.fragment,t),v(Nt.$$.fragment,t),v(St.$$.fragment,t),v(Tt.$$.fragment,t),v(It.$$.fragment,t),v(Mt.$$.fragment,t),v(qt.$$.fragment,t),v(Lt.$$.fragment,t),v(Ut.$$.fragment,t),v(zt.$$.fragment,t),v(an.$$.fragment,t),v(sn.$$.fragment,t),v(ln.$$.fragment,t),v(Ve.$$.fragment,t),v(pn.$$.fragment,t),v(cn.$$.fragment,t),v(fn.$$.fragment,t),v(mn.$$.fragment,t),v(hn.$$.fragment,t),v(Ye.$$.fragment,t),v(gn.$$.fragment,t),v(_n.$$.fragment,t),v(vn.$$.fragment,t),v(bn.$$.fragment,t),v(yn.$$.fragment,t),v($n.$$.fragment,t),v(et.$$.fragment,t),Ji=!1},d(t){n(w),t&&n(D),t&&n(x),b(m),t&&n(Hs),t&&n(ee),b(dt),t&&n(Ws),t&&n(ft),t&&n(Vs),t&&n(En),t&&n(Bs),t&&n(kn),t&&n(Ks),t&&n(Cn),t&&n(Ys),t&&n(_e),t&&n(Xs),t&&n(Pn),t&&n(Zs),t&&n(ve),t&&n(Js),t&&n(te),b(_t),t&&n(Qs),t&&n(ye),t&&n(ei),t&&n(ae),b(yt),t&&n(ti),t&&n($e),t&&n(ni),t&&n(xe),t&&n(oi),t&&n(Ee),t&&n(ai),b(xt,t),t&&n(si),t&&n(Tn),t&&n(ii),t&&n(V),t&&n(ri),t&&n(Mn),t&&n(li),b(Et,t),t&&n(pi),t&&n(Fn),t&&n(ci),b(kt,t),t&&n(di),t&&n(qn),t&&n(fi),b(Ct,t),t&&n(mi),t&&n(Ln),t&&n(ui),t&&n(Gn),t&&n(hi),t&&n(ke),t&&n(gi),b(Pt,t),t&&n(_i),t&&n(Ce),t&&n(vi),b(jt,t),t&&n(bi),t&&n(Rn),t&&n(yi),b(Dt,t),t&&n(wi),t&&n(Hn),t&&n($i),t&&n(Wn),t&&n(xi),t&&n(se),t&&n(Ei),t&&n(ie),b(Nt),t&&n(ki),t&&n(je),t&&n(Ci),t&&n(Kn),t&&n(Pi),t&&n(De),t&&n(ji),t&&n(re),b(St),t&&n(Di),t&&n(Yn),t&&n(Ni),t&&n(Xn),t&&n(Si),t&&n(Zn),t&&n(Ti),b(Tt,t),t&&n(Ii),t&&n(Jn),t&&n(Ai),t&&n(le),b(It),t&&n(Mi),t&&n(Qn),t&&n(Fi),t&&n(At),t&&n(qi),t&&n(eo),t&&n(Li),b(Mt,t),t&&n(Gi),t&&n(Ft),t&&n(Ui),t&&n(pe),b(qt),t&&n(Oi),b(Lt,t),t&&n(zi),t&&n(Gt),t&&n(Ri),t&&n(ce),b(Ut),t&&n(Hi),t&&n(B),t&&n(Wi),t&&n(Ae),t&&n(Vi),t&&n(de),b(zt),t&&n(Bi),t&&n(Fe),t&&n(Ki),t&&n(fe),b(an),t&&n(Yi),t&&n($),b(sn),b(ln),b(Ve),b(pn),b(cn),b(fn),b(mn),b(hn),b(Ye),b(gn),b(_n),b(vn),t&&n(Xi),t&&n(ue),b(bn),t&&n(Zi),t&&n(I),b(yn),b($n),b(et)}}}const cg={local:"texttoimage-generation-with-controlnet-conditioning",sections:[{local:"overview",title:"Overview"},{local:"available-pipelines",title:"Available Pipelines:"},{local:"usage-example",title:"Usage example"},{local:"combining-multiple-conditionings",sections:[{local:"canny-conditioning",title:"Canny conditioning"},{local:"openpose-conditioning",title:"Openpose conditioning"},{local:"running-controlnet-with-multiple-conditionings",title:"Running ControlNet with multiple conditionings"}],title:"Combining multiple conditionings"},{local:"available-checkpoints",sections:[{local:"controlnet-with-stable-diffusion-15",title:"ControlNet with Stable Diffusion 1.5"}],title:"Available checkpoints"},{local:"diffusers.StableDiffusionControlNetPipeline",title:"StableDiffusionControlNetPipeline"},{local:"diffusers.FlaxStableDiffusionControlNetPipeline",title:"FlaxStableDiffusionControlNetPipeline"}],title:"Text-to-Image Generation with ControlNet Conditioning"};function dg(he){return sg(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class _g extends tg{constructor(w){super();ng(this,w,dg,pg,og,{})}}export{_g as default,cg as metadata};
